        SOLGNUDIR = /usr/local
            SOLCC = $(SOLGNUDIR)/bin/g++

          ARCHDIR = i386-redhat-linux
          PRODDIR = 2.96
           GNUDIR = /usr/local
               CC = $(GNUDIR)/bin/g++

          INCLUDE = /usr/include: \
                    /usr/include/sys: \
                    /usr/openwin/include: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)/include

  LD_LIBRARY_PATH = /usr/lib: \
                    /usr/openwin/lib: \
                    $(GNUDIR)/lib: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)

             INCS  = -Iserver -Iclient -Iinclude -I. -I/usr/include/pgsql

          CLIINCS  = -Iserver -Iclient -Iinclude -I. -I/usr/include/SDL -I/usr/include/freetype2

             LIBS  = -lnsl -lpthread -lcurses -lm  -L/usr/sfw/lib -lsocket 

          CLILIBS  = -lGL -lGLU -lm -L/usr/lib -Wl,-rpath,/usr/lib -lSDL -lpthread -lSDL_image -lcurses -lfreetype

             FLAGS = -g -Wall -Winline 

          CLIFLAGS = -g 

             DEFS  = -D_REENTRANT -DSOLARIS 
          SOLDEFS  = -D_REENTRANT -DSOLARIS 
       SOLCONDEFS  = -D_REENTRANT -DSOLARIS -DCONSOLE
          SRVDEFS  = -D_REENTRANT -DSOLARIS -DSERVER 
          CLIDEFS  = -D_REENTRANT -DSOLARIS -DCLIENT
          CONDEFS  = -D_REENTRANT -DSOLARIS -DCONSOLE
          CHRDEFS  = -D_REENTRANT -DSOLARIS -DCONSOLE

all	   : server client charclient console assem 

server     : server/debug server/debug/logs shared/debug \
	     server/debug/server.o     shared/debug/cusock.o  shared/debug/util.o     shared/debug/cthread.o\
	     server/debug/dispatcher.o server/debug/conserv.o server/debug/cpool.o    server/debug/cserver.o\
	     shared/debug/citem.o      shared/debug/parse.o   shared/debug/cmessage.o shared/debug/cstring.o\
	     server/debug/handler.o    shared/debug/cengine.o shared/debug/ctimer.o   shared/debug/cqueue.o\
	     shared/debug/mygetline.o;  \
	     $(CC) \
	     server/debug/server.o     shared/debug/cusock.o  shared/debug/util.o     shared/debug/cthread.o   \
	     server/debug/dispatcher.o server/debug/conserv.o server/debug/cpool.o    server/debug/cserver.o\
	     shared/debug/citem.o      shared/debug/parse.o   shared/debug/cmessage.o shared/debug/cstring.o\
	     server/debug/handler.o    shared/debug/cengine.o shared/debug/ctimer.o   shared/debug/cqueue.o\
	     shared/debug/mygetline.o\
	     $(LIBS) $(INCS) $(FLAGS) $(SRVDEFS) -o server/debug/server

client     : client/debug client/debug/world1.dat client/debug/logs shared/debug \
	     client/debug/client.o   shared/debug/cwutil.o   client/debug/input.o    shared/debug/cstring.o\
	     shared/debug/cfont.o    shared/debug/ctextwin.o shared/debug/clist.o    shared/debug/cpart.o\
	     shared/debug/cmodel.o   shared/debug/cinode.o   shared/debug/cworld.o   shared/debug/cregion.o\
	     shared/debug/cusock.o   shared/debug/util.o     shared/debug/ctimer.o   client/debug/clportmon.o\
	     shared/debug/citem.o    shared/debug/cengine.o ;  \
             $(CC) \
	     client/debug/client.o   shared/debug/cwutil.o   client/debug/input.o    shared/debug/cstring.o \
	     shared/debug/cfont.o    shared/debug/ctextwin.o shared/debug/clist.o    shared/debug/cpart.o\
	     shared/debug/cmodel.o   shared/debug/cinode.o   shared/debug/cworld.o   shared/debug/cregion.o\
	     shared/debug/cusock.o   shared/debug/util.o     shared/debug/ctimer.o   client/debug/clportmon.o\
	     shared/debug/citem.o    shared/debug/cengine.o \
	     $(CLIINCS) $(CLIDEFS) $(CLILIBS) $(CLIFLAGS) -o client/debug/client  ;
	     cp objects/*.png client/debug 
	     cp objects/*.mod client/debug 
	     cp objects/*.dat client/debug 
	     cp objects/*.ttf client/debug 

charclient   : charclient/debug charclient/debug/logs shared/debug \
	     charclient/debug/charclient.o shared/debug/cusock.o shared/debug/util.o shared/debug/cstring.o\
	     shared/debug/cengine.o ;  \
             $(CC) \
	     charclient/debug/charclient.o shared/debug/cusock.o shared/debug/util.o shared/debug/cstring.o\
	     shared/debug/cengine.o    \
	     $(LIBS) $(INCS) $(FLAGS) $(CHRDEFS) -o charclient/debug/charclient  ;
	     cp charclient/debug/charclient charclient/debug0 
	     cp charclient/debug/charclient charclient/debug1 

console	     : console/debug console/debug/logs shared/debug \
	     console/debug/console.o    shared/debug/util.o     shared/debug/cusock.o   shared/debug/cstring.o  \
	     console/debug/conportmon.o shared/debug/cengine.o  shared/debug/mygetline.o;\
	     $(CC) \
	     console/debug/console.o    shared/debug/util.o     shared/debug/cusock.o   shared/debug/cstring.o  \
	     console/debug/conportmon.o shared/debug/cengine.o  shared/debug/mygetline.o\
	     $(LIBS) $(INCS) $(FLAGS) $(CONDEFS) -o console/debug/console ;

assem	     : assem/debug assem/debug/logs shared/debug \
	     assem/debug/assem.o    shared/debug/util.o     shared/debug/cstring.o      shared/debug/cengine.o\
	     shared/debug/mygetline.o;\
	     $(CC) \
	     assem/debug/assem.o    shared/debug/util.o     shared/debug/cstring.o      shared/debug/cengine.o\
	     shared/debug/mygetline.o  \
	     $(LIBS) $(INCS) $(FLAGS) $(CONDEFS) -o assem/debug/assem ;

solassem     : assem/soldebug assem/soldebug/logs shared/soldebug \
	     assem/soldebug/assem.o    shared/soldebug/util.o     shared/soldebug/cstring.o      shared/soldebug/cengine.o\
	     shared/soldebug/mygetline.o;\
	     $(SOLCC) \
	     assem/soldebug/assem.o    shared/soldebug/util.o     shared/soldebug/cstring.o      shared/soldebug/cengine.o\
	     shared/soldebug/mygetline.o  \
	     $(LIBS) $(INCS) $(FLAGS) $(SOLCONDEFS) -o assem/soldebug/assem ;

install	     : 
	     install -d $(bindir)
	     install -s -m 755 server/debug/server     $(bindir)/server
	     install -s -m 755 client/debug/client     $(bindir)/client
	     install -s -m 755 console/debug/console   $(bindir)/console
	     install -s -m 755 assem/debug/assem       $(bindir)/assem

		
server/debug/conserv.o	: server/conserv.cpp include/wiii_util.h include/worldiii.h\
			include/console.h include/cusock.hpp;
			$(CC) -c server/conserv.cpp $(INCS) $(FLAGS) $(CONDEFS) -o server/debug/conserv.o

server/debug/server.o	: server/server.cpp include/rudp.h include/cusock.hpp;
			$(CC) -c server/server.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o server/debug/server.o

server/debug/dispatcher.o	: server/dispatcher.cpp include/cusock.hpp;
			$(CC) -c server/dispatcher.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o server/debug/dispatcher.o

shared/debug/cqueue.o	: shared/cqueue.cpp include/cqueue.hpp ;
			$(CC) -c shared/cqueue.cpp $(CLIINCS) $(CLIFLAGS) $(SRVDEFS) -o shared/debug/cqueue.o

shared/debug/cmodel.o	: shared/cmodel.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cmodel.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cmodel.o

shared/soldebug/cengine.o	: shared/cengine.cpp include/cengine.hpp ;
			$(SOLCC) -c shared/cengine.cpp $(CLIINCS) $(CLIFLAGS) $(SOLDEFS) -o shared/soldebug/cengine.o

shared/debug/cengine.o	: shared/cengine.cpp include/cengine.hpp ;
			$(CC) -c shared/cengine.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cengine.o

shared/debug/cinode.o	: shared/cinode.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cinode.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cinode.o

shared/debug/cregion.o	: shared/cregion.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cregion.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cregion.o

shared/debug/cworld.o	: shared/cworld.cpp include/cworld.hpp include/cfont.hpp client/client.h;
			$(CC) -c shared/cworld.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cworld.o

shared/debug/cwutil.o	: shared/cwutil.cpp include/cworld.hpp ;
			$(CC) -c shared/cwutil.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o shared/debug/cwutil.o

shared/debug/cpart.o	: shared/cpart.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cpart.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o shared/debug/cpart.o

shared/debug/clist.o	: shared/clist.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/clist.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o shared/debug/clist.o

shared/debug/ctextwin.o	: shared/ctextwin.cpp include/ctextwin.hpp include/cfont.hpp client/client.h;
			$(CC) -c shared/ctextwin.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o shared/debug/ctextwin.o

shared/debug/cfont.o	: shared/cfont.cpp include/cfont.hpp client/client.h;
			$(CC) -c shared/cfont.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o shared/debug/cfont.o

client/debug/clportmon.o	: client/clportmon.cpp include/cworld.hpp include/cusock.hpp include/wiii_util.h;
			$(CC) -c client/clportmon.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o client/debug/clportmon.o

client/debug/input.o	: client/input.cpp client/client.h include/cstring.hpp include/cworld.hpp include/cusock.hpp;
			$(CC) -c client/input.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o client/debug/input.o

client/debug/client.o	: client/client.cpp include/rudp.h include/cusock.hpp include/cworld.hpp client/client.h;
			$(CC) -c client/client.cpp $(CLIINCS) $(CLIFLAGS) $(CLIDEFS) -o client/debug/client.o

charclient/debug/charclient.o	: charclient/charclient.cpp include/rudp.h include/cusock.hpp;
			$(CC) -c charclient/charclient.cpp $(INCS) $(FLAGS) $(CONDEFS) -o charclient/debug/charclient.o

shared/debug/ctimer.o   : shared/ctimer.cpp include/ctimer.hpp include/wiii_util.h;
			$(CC) -c shared/ctimer.cpp $(INCS) $(FLAGS) $(CLIDEFS) -o shared/debug/ctimer.o

shared/debug/cthread.o  : shared/cthread.cpp include/cthread.hpp include/rudp.h include/wiii_util.h;
			$(CC) -c shared/cthread.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o shared/debug/cthread.o

shared/debug/citem.o    : shared/citem.cpp include/citem.hpp include/worldiii.h include/cusock.hpp;
			$(CC) -c shared/citem.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o shared/debug/citem.o

server/debug/cpool.o    : server/cpool.cpp server/cpool.hpp include/wiii_util.h;
			$(CC) -c server/cpool.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o server/debug/cpool.o

server/debug/cserver.o  : server/cserver.cpp server/cserver.hpp include/wiii_util.h;
			$(CC) -c server/cserver.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o server/debug/cserver.o

shared/debug/cmessage.o : shared/cmessage.cpp include/cmessage.hpp include/wiii_structures.h include/wiii_util.h\
			include/cstring.hpp include/worldiii.h;
			$(CC) -c shared/cmessage.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o shared/debug/cmessage.o

shared/debug/cusock.o   : shared/cusock.cpp include/cusock.hpp include/rudp.h include/wiii_util.h;
			$(CC) -c shared/cusock.cpp $(INCS) $(FLAGS) $(SRVDEFS) -o shared/debug/cusock.o

shared/soldebug/cstring.o  : shared/cstring.cpp include/cstring.hpp include/rudp.h include/wiii_util.h;
			$(SOLCC) -c shared/cstring.cpp $(INCS) $(FLAGS) $(SOLDEFS) -o shared/soldebug/cstring.o

shared/debug/cstring.o  : shared/cstring.cpp include/cstring.hpp include/rudp.h include/wiii_util.h;
			$(CC) -c shared/cstring.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/cstring.o

shared/soldebug/util.o  : shared/util.cpp include/cstring.hpp include/wiii_util.h ;
			$(SOLCC) -c shared/util.cpp $(INCS) $(FLAGS) $(SOLDEFS) -o shared/soldebug/util.o

shared/debug/util.o     : shared/util.cpp include/cstring.hpp include/wiii_util.h ;
			$(CC) -c shared/util.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/util.o

shared/debug/parse.o    : shared/parse.cpp include/wiii_util.h server/cpool.hpp include/cmessage.hpp;
			$(CC) -c shared/parse.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/parse.o

server/debug/handler.o  : server/handler.cpp include/wiii_structures.h include/worldiii.h \
			server/cserver.hpp server/cpool.hpp;
			$(CC) -c server/handler.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/handler.o

assem/debug/assem.o     : assem/assem.cpp include/cstring.hpp include/wiii_structures.h include/wiii_util.h \
			include/wiii_curses.h include/cengine.hpp;
			$(CC) -c assem/assem.cpp $(INCS) $(FLAGS) $(DEFS) -o assem/debug/assem.o

assem/soldebug/assem.o  : assem/assem.cpp include/cstring.hpp include/wiii_structures.h include/wiii_util.h \
			include/wiii_curses.h include/cengine.hpp;
			$(SOLCC) -c assem/assem.cpp $(INCS) $(FLAGS) $(SOLDEFS) -o assem/soldebug/assem.o

console/debug/console.o : console/console.cpp include/console.h include/cusock.hpp include/worldiii.h include/wiii_util.h \
			include/wiii_curses.h;
			$(CC) -c console/console.cpp $(INCS) $(FLAGS) $(DEFS) -o console/debug/console.o

console/debug/conportmon.o : console/conportmon.cpp include/cusock.hpp;
			$(CC) -c console/conportmon.cpp $(INCS) $(FLAGS) $(DEFS) -o console/debug/conportmon.o

shared/soldebug/mygetline.o : shared/mygetline.cpp include/mygetline.h;
			$(SOLCC) -c shared/mygetline.cpp $(INCS) $(FLAGS) $(SOLDEFS) -o shared/soldebug/mygetline.o

shared/debug/mygetline.o : shared/mygetline.cpp include/mygetline.h;
			$(SOLCC) -c shared/mygetline.cpp $(INCS) $(FLAGS) $(SOLDEFS) -o shared/debug/mygetline.o




assem/soldebug      :
	test ! -d assem/soldebug && mkdir assem/soldebug

assem/soldebug/logs :
	test ! -d assem/soldebug/logs && mkdir assem/soldebug/logs

assem/debug      :
	test ! -d assem/debug && mkdir assem/debug

assem/debug/logs :
	test ! -d assem/debug/logs && mkdir assem/debug/logs

console/debug      :
	test ! -d console/debug && mkdir console/debug

console/debug/logs :
	test ! -d console/debug/logs && mkdir console/debug/logs

server/debug      :
	test ! -d server/debug && mkdir server/debug

server/debug/logs :
	test ! -d server/debug/logs && mkdir server/debug/logs


client/debug      :
	test ! -d client/debug && mkdir client/debug

client/debug/world1.dat :
	cp objects/*.png client/debug 
	cp objects/*.mod client/debug 
	cp objects/*.dat client/debug 

charclient/debug      :
	test ! -d charclient/debug && mkdir charclient/debug
	test ! -d charclient/debug0 && mkdir charclient/debug0
	test ! -d charclient/debug1 && mkdir charclient/debug1

copyfiles :
	cp objects/*.png cp objects/*.mod cp objects/*.dat /wiii/bin 
	cp server/debug/server         /wiii/bin 
	cp console/debug/console       /wiii/bin 
	cp client/debug/client         /wiii/bin 
	cp charclient/debug/charclient /wiii/bin 

client/debug/logs :
	test ! -d client/debug/logs &&  mkdir client/debug/logs

charclient/debug/logs :
	test ! -d charclient/debug/logs &&  mkdir charclient/debug/logs
	test ! -d charclient/debug0/logs && mkdir charclient/debug0/logs
	test ! -d charclient/debug1/logs && mkdir charclient/debug1/logs

shared/soldebug      :
	test ! -d shared/soldebug && mkdir shared/soldebug

shared/debug      :
	test ! -d shared/debug && mkdir shared/debug

.PHONY : clean
.PHONY : doc

doc   :
	doxygen doc/wiii.dox

clean :
	rm -rf client/debug 
	rm -rf charclient/debug 
	rm -rf charclient/debug0 
	rm -rf charclient/debug1 
	rm -rf server/debug 
	rm -rf server/soldebug 
	rm -rf console/debug 
	rm -rf assem/debug 
	rm -rf assem/soldebug 
	rm -rf modeler/debug 
	rm -rf shared/debug 
	rm -rf shared/soldebug 
	rm -rf misc/debug 
	rm -rf doc/doxygen/html 
	rm -rf doc/doxygen/latex 

