%{
#include <stdio.h>
#include <string.h>

#define YYSTYPE char *

int yydebug=0;

void yyerror(const char *str)
{
	fprintf(stderr,"Assembler error:: %s\n",str);
}

int yywrap()
{
	return 1;
}

main()
{
	yyparse();
}

%}

%token DBLSLASH SEMICOLON STRING EQUTOK DBTOK DSTOK DFTOK ORGTOK EOL LDITOK STOPTOK DECTOK NUMBER JNZTOK COMMA
	DBLQUOTE
%%

commands:
	|	 
	commands command EOL
	;

command: 
	STRING ORGTOK NUMBER  
	{
		printf("Found ORG command\n");
	}
	|
	LDITOK STRING COMMA NUMBER COMMA NUMBER COMMA NUMBER
	{
		printf("Found LDI command number\n");
	}
	|
	LDITOK STRING COMMA NUMBER COMMA NUMBER COMMA quoted_string
	{
		printf("Found LDI command string\n");
	}
	|
	STRING NUMBER
	{
		printf("Found Custom opcode\n");
	}
	|
	DECTOK STRING COMMA NUMBER
	{
		printf("Found DEC opcode\n");
	}
	|
	JNZTOK STRING 
	{
		printf("Found JNZ opcode\n");
	}
	|
	STOPTOK 
	{
		printf("Found STOP opcode\n");
	}
	|
	EOL 
	{
		printf("Found empty line \n");
	}
	;

quoted_string:
	DBLQUOTE STRING DBLQUOTE
	;

