          ARCHDIR = i386-redhat-linux
          PRODDIR = 2.8.1
           GNUDIR = /opt/sfw
               CC = $(GNUDIR)/bin/gcc

          INCLUDE = /usr/include: \
                    /usr/include/sys: \
                    /usr/openwin/include: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)/include

  LD_LIBRARY_PATH = /usr/lib: \
                    /postgres/lib: \
                    /usr/openwin/lib: \
                    $(GNUDIR)/lib: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)

             INCS  = -Iinclude -I. -I/usr/include/pgsql

#            LIBS  = -lnsl -lpthread -lcurses -lpq -lm -lsocket
             LIBS  = -lnsl -lpthread -lcurses -lm -lsocket

             FLAGS = -g 

             DEFS  = -D_REENTRANT -DCLIENT -DSOLARIS

all	   : client

client     : client/debug client/debug/logs \
	     client/debug/client.o client/debug/cusock.o client/debug/util.o ;  \
             $(CC) \
	     client/debug/client.o client/debug/cusock.o client/debug/util.o    \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o client/debug/client  

client/debug/client.o	: client/client.cpp include/udp.h include/cusock.hpp;
			$(CC) -c client/client.cpp $(INCS) $(FLAGS) $(DEFS) -o client/debug/client.o

client/debug/cusock.o  : shared/cusock.cpp include/cusock.hpp include/rudp.h;
			$(CC) -c shared/cusock.cpp $(INCS) $(FLAGS) $(DEFS) -o client/debug/cusock.o

client/debug/util.o    : shared/util.cpp include/wiii_util.h ;
			$(CC) -c shared/util.cpp $(INCS) $(FLAGS) $(DEFS) -o client/debug/util.o



client/debug      :
	test ! -d client/debug && mkdir client/debug

client/debug/logs :
	test ! -d client/debug/logs && mkdir client/debug/logs

.PHONY : clean

clean :
	rm -r client/debug 
