          ARCHDIR = i386-redhat-linux
          PRODDIR = 2.96
           GNUDIR = /opt/sfw
               CC = $(GNUDIR)/bin/g++

          INCLUDE = /usr/include: \
                    /usr/include/sys: \
                    /usr/openwin/include: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)/include

  LD_LIBRARY_PATH = /usr/lib: \
                    /usr/openwin/lib: \
                    $(GNUDIR)/lib: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)

             INCS  = -Iserver -Iclient -Iinclude -I. -I/usr/include/pgsql

             CLIINCS  = -Iserver -Iclient -Iinclude -I. -I/usr/include/SDL 

             LIBS  = -lnsl -lcurses -lm -lpq -lsocket -lpthread

             CLILIBS  = -lGL -lGLU -lm -L/usr/lib -Wl,-rpath,/usr/lib -lSDL -lSDL_image -lcurses -lpthread

             FLAGS = -g -Wall -Winline -fstack-check

             CLIFLAGS = -g 

             DEFS  = -D_REENTRANT -DSOLARIS 

all	   : server client charclient console

server     : server/debug server/debug/logs shared/debug \
	     server/debug/main.o shared/debug/cusock.o shared/debug/util.o shared/debug/cthread.o\
	     server/debug/dispatcher.o server/debug/conserv.o server/debug/cpool.o    server/debug/cserver.o\
	     server/debug/citem.o      shared/debug/parse.o   shared/debug/cmessage.o shared/debug/cstring.o\
	     server/debug/handler.o    shared/debug/cengine.o;  \
	     $(CC) \
	     server/debug/main.o shared/debug/cusock.o shared/debug/util.o shared/debug/cthread.o   \
	     server/debug/dispatcher.o server/debug/conserv.o server/debug/cpool.o    server/debug/cserver.o\
	     server/debug/citem.o      shared/debug/parse.o   shared/debug/cmessage.o shared/debug/cstring.o\
	     server/debug/handler.o    shared/debug/cengine.o\
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o server/debug/server


client     : client/debug client/debug/data client/debug/logs shared/debug \
	     client/debug/client.o   shared/debug/cwutil.o   client/debug/input.o    shared/debug/cstring.o\
	     shared/debug/cfont.o    shared/debug/ctextwin.o shared/debug/clist.o    shared/debug/cpart.o\
	     shared/debug/cmodel.o   shared/debug/cinode.o   shared/debug/cworld.o   shared/debug/cregion.o\
	     shared/debug/cusock.o   shared/debug/util.o;  \
             $(CC) \
	     client/debug/client.o   shared/debug/cwutil.o   client/debug/input.o    shared/debug/cstring.o \
	     shared/debug/cfont.o    shared/debug/ctextwin.o shared/debug/clist.o    shared/debug/cpart.o\
	     shared/debug/cmodel.o   shared/debug/cinode.o   shared/debug/cworld.o   shared/debug/cregion.o\
	     shared/debug/cusock.o   shared/debug/util.o\
	     $(CLIINCS) $(DEFS) $(CLILIBS) $(CLIFLAGS) -o client/debug/client  ;
	     cp objects/*.png client/debug 
	     cp objects/*.mod client/debug 
	     cp objects/*.dat client/debug 

charclient   : charclient/debug charclient/debug/logs shared/debug \
	     charclient/debug/charclient.o shared/debug/cusock.o shared/debug/util.o ;  \
             $(CC) \
	     charclient/debug/charclient.o shared/debug/cusock.o shared/debug/util.o    \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o charclient/debug/charclient  ;
	     cp charclient/debug/charclient charclient/debug0 
	     cp charclient/debug/charclient charclient/debug1 

console	     : console/debug console/debug/logs shared/debug \
	     console/debug/main.o    shared/debug/util.o     shared/debug/cusock.o \
	     console/debug/portmon.o ;\
	     $(CC) \
	     console/debug/main.o    shared/debug/util.o     shared/debug/cusock.o \
	     console/debug/portmon.o  \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o console/debug/console ;

		
server/debug/conserv.o	: server/conserv.cpp include/wiii_util.h include/worldiii.h\
			include/console.h include/wiii_types.h include/cusock.hpp;
			$(CC) -c server/conserv.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/conserv.o

server/debug/main.o	: server/main.cpp include/rudp.h include/cusock.hpp;
			$(CC) -c server/main.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/main.o

server/debug/dispatcher.o	: server/dispatcher.cpp include/cusock.hpp;
			$(CC) -c server/dispatcher.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/dispatcher.o

shared/debug/cmodel.o	: shared/cmodel.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cmodel.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cmodel.o

shared/debug/cengine.o	: shared/cengine.cpp include/cengine.hpp ;
			$(CC) -c shared/cengine.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cengine.o

shared/debug/cinode.o	: shared/cinode.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cinode.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cinode.o

shared/debug/cregion.o	: shared/cregion.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cregion.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cregion.o

shared/debug/cworld.o	: shared/cworld.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cworld.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cworld.o

shared/debug/cwutil.o	: shared/cwutil.cpp include/cworld.hpp ;
			$(CC) -c shared/cwutil.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cwutil.o

shared/debug/cpart.o	: shared/cpart.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/cpart.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cpart.o

shared/debug/clist.o	: shared/clist.cpp include/cworld.hpp client/client.h;
			$(CC) -c shared/clist.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/clist.o

shared/debug/ctextwin.o	: shared/ctextwin.cpp include/ctextwin.hpp client/client.h;
			$(CC) -c shared/ctextwin.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/ctextwin.o

shared/debug/cfont.o	: shared/cfont.cpp include/cfont.hpp client/client.h;
			$(CC) -c shared/cfont.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o shared/debug/cfont.o

#client/debug/font.o	: client/font.cpp include/rudp.h include/cusock.hpp client/client.h;
#			$(CC) -c client/font.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o client/debug/font.o

client/debug/input.o	: client/input.cpp client/client.h include/cstring.hpp include/cworld.hpp;
			$(CC) -c client/input.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o client/debug/input.o

client/debug/client.o	: client/client.cpp include/rudp.h include/cusock.hpp include/cworld.hpp client/client.h;
			$(CC) -c client/client.cpp $(CLIINCS) $(CLIFLAGS) $(DEFS) -o client/debug/client.o

charclient/debug/charclient.o	: charclient/charclient.cpp include/rudp.h include/cusock.hpp;
			$(CC) -c charclient/charclient.cpp $(INCS) $(FLAGS) $(DEFS) -o charclient/debug/charclient.o

shared/debug/cthread.o  : shared/cthread.cpp include/cthread.hpp include/rudp.h include/wiii_util.h;
			$(CC) -c shared/cthread.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/cthread.o

server/debug/citem.o    : server/citem.cpp server/citem.hpp include/wiii_types.h include/worldiii.h include/cusock.hpp;
			$(CC) -c server/citem.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/citem.o

server/debug/cpool.o    : server/cpool.cpp server/cpool.hpp include/wiii_util.h;
			$(CC) -c server/cpool.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/cpool.o

server/debug/cserver.o  : server/cserver.cpp server/cserver.hpp include/wiii_util.h;
			$(CC) -c server/cserver.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/cserver.o

shared/debug/cmessage.o : shared/cmessage.cpp include/cmessage.hpp include/wiii_structures.h include/wiii_util.h\
			include/cstring.hpp include/worldiii.h;
			$(CC) -c shared/cmessage.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/cmessage.o

shared/debug/cusock.o   : shared/cusock.cpp include/cusock.hpp include/rudp.h include/wiii_util.h;
			$(CC) -c shared/cusock.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/cusock.o

shared/debug/cstring.o  : shared/cstring.cpp include/cstring.hpp include/rudp.h include/wiii_util.h;
			$(CC) -c shared/cstring.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/cstring.o

shared/debug/util.o     : shared/util.cpp include/wiii_types.h include/wiii_util.h ;
			$(CC) -c shared/util.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/util.o

shared/debug/parse.o    : shared/parse.cpp include/wiii_types.h include/wiii_util.h server/cpool.hpp include/cmessage.hpp;
			$(CC) -c shared/parse.cpp $(INCS) $(FLAGS) $(DEFS) -o shared/debug/parse.o

server/debug/handler.o  : server/handler.cpp include/wiii_types.h include/wiii_structures.h include/worldiii.h \
			server/cserver.hpp server/cpool.hpp;
			$(CC) -c server/handler.cpp $(INCS) $(FLAGS) $(DEFS) -o server/debug/handler.o

console/debug/main.o    : console/main.cpp include/console.h include/worldiii.h include/wiii_util.h \
			include/wiii_types.h include/wiii_curses.h;
			$(CC) -c console/main.cpp $(INCS) $(FLAGS) $(DEFS) -o console/debug/main.o

console/debug/portmon.o : console/portmon.cpp include/cusock.hpp;
			$(CC) -c console/portmon.cpp $(INCS) $(FLAGS) $(DEFS) -o console/debug/portmon.o

console/debug      :
	test ! -d console/debug && mkdir console/debug

console/debug/logs :
	test ! -d console/debug/logs && mkdir console/debug/logs


server/debug      :
	test ! -d server/debug && mkdir server/debug

server/debug/logs :
	test ! -d server/debug/logs && mkdir server/debug/logs


client/debug      :
	test ! -d client/debug && mkdir client/debug

client/debug/data      :
	test ! -d client/debug/data && mkdir client/debug/data

charclient/debug      :
	test ! -d charclient/debug && mkdir charclient/debug
	test ! -d charclient/debug0 && mkdir charclient/debug0
	test ! -d charclient/debug1 && mkdir charclient/debug1

client/debug/logs :
	test ! -d client/debug/logs &&  mkdir client/debug/logs

charclient/debug/logs :
	test ! -d charclient/debug/logs &&  mkdir charclient/debug/logs
	test ! -d charclient/debug0/logs && mkdir charclient/debug0/logs
	test ! -d charclient/debug1/logs && mkdir charclient/debug1/logs

shared/debug      :
	test ! -d shared/debug && mkdir shared/debug

.PHONY : clean

clean :
	rm -rf client/debug 
	rm -rf charclient/debug 
	rm -rf charclient/debug0 
	rm -rf charclient/debug1 
	rm -rf server/debug 
	rm -rf console/debug 
	rm -rf shared/debug 

