///////////////////////////////////////////////////////////////////////////////////////////////////
// Client and modeler NEW VERSION
// cworld.hpp : These classes can
// read in from file the description list of models that comprise the world
// save world state to file render world (collection of models) to screen
//	with animation
// 
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 02 Feb 2004
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact:
//		email	worldii@viagloria.com
//		web		www.viagloria.com
//
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// The CWorld Class will start to be come more of a real rendering engine.
// It will be where 
//	- keyboard input is taken
//	- where the scene is rendered
//	- where simulation is done
//	- where preculling based on 
//		- visibility
//		- region 
//		- whether inside something or not is done.
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(_CWORLD_HPP_)  //skip this stuff if it has already been seen
#define _CWORLD_HPP_        //by the compiler

///////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////////////////////////
//#include <d3dx8math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "SDL.h"
#include "wiii_types.h"
#include "wiii_structures.h"
#include "worldiii.h"
//#include "cwintimer.hpp"

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
///////////////////////////////////////////////////////////////////////////////////////////////////
class CIndex;
class CRegion;
class CPart;
class CInode;
class CPortal;
class CRoom;
  
///////////////////////////////////////////////////////////////////////////////////////////////////
// CWorld class
///////////////////////////////////////////////////////////////////////////////////////////////////
//class CWorld
//{
//
//public:
//			CWorld();			// Init pointers
//			~CWorld();
//	BOOL		Init();				// sets pointers into data struct;
//	BOOL		Init(BOOL (*pfunc)(char *,HWND hwndTV,int,LPARAM),HWND hwndTV);	// sets pointers into data struct;
//							// sets size;
//							// sets size;
//	BOOL		InsertRegion(CRegion *r);	// Given an existing REGION struct
//							// Insert it at beginning of list
//	BOOL		InsertModel(CModel *,CRegion *);// Given an existing CModel 
//							// Insert it at beginning of list
//	BOOL		InsertModel(CModel *,CModel *);	// Given an existing CModel 
//							// Insert it as a submodel
//	BOOL		InsertModel(CModel *,CInode *);	// Given an existing CModel 
//							// Insert it in given list
//	BOOL		AddToMovers(CModel *);		// Given an existing CModel 
//							// Add it to movers list
//	CRegion		*FindRegion(int,int,int);	// Find the region matching the indecies given
//	CModel		*FindModel(CString *);		// Find the model matching the filename given
//							// starting from the given region
//
//
//	void		Print();			// DEBUGG !!!!!! DONOT USE IN PRODUCTION!!!!
//	void		Print(CRegion *);		// DEBUGG !!!!!! DONOT USE IN PRODUCTION!!!!
//	void		Print(CInode *,CModel *);	// DEBUGG !!!!!! DONOT USE IN PRODUCTION!!!!
//	void		Print(CModel *,CModel *);	// DEBUGG !!!!!! DONOT USE IN PRODUCTION!!!!
//	void		Print(CPart *);			// DEBUGG !!!!!! DONOT USE IN PRODUCTION!!!!
//	void		Traverse();			// 
//	void		Traverse(CRegion *);		// 
//	void		Traverse(CInode *,CModel *);	// 
//	void		Traverse(CModel *,CModel *);	// 
//	void		Traverse(CPart *);		// 
//	void		NewMover(posup*);				// Add a new mover for simulation & display
//	void		MoversUpdate(posup*);				// Allows for updating the movement state of a moving object
//	void		SimMover(int);					// Sim will be moved to inside cworld object
//	void		DoMe();						// Get my inputs and do my motion
//	void		Sim();						// Sim will be moved to inside cworld object
//	void		SendUpdatesToServer();				// This updates server with my state
//	void		Run();
//	void		SetModel(int id, CString *o);
//	void		Ins(BOOL);
//	void		Del(BOOL);
//	void		PgUp(BOOL);
//	void		PgDn(BOOL);
//	void		LevelLook();
//	void		UpArrow(BOOL);
//	void		DnArrow(BOOL);
//	void		LeftArrow(BOOL);
//	void		RightArrow(BOOL);
//	void		SetSpeed(float);
//	void		GetPosup(posup*);				// Get all state at once
//	void		GetPos(float*,float*,float*);			// Get xpos, ypos, zpos
//	void		SetObjID(CString *o);
//	BOOL		Load(char *filename);				// load the world from the specified file
//	BOOL		LoadMover(char *filename);			// load the model from the specified file
//	HRESULT		InitDeviceObjects(LPDIRECT3DDEVICE8 );
//	HRESULT		Destroy();
//	HRESULT		InvalidateDeviceObjects();
//	HRESULT		RestoreDeviceObjects(LPDIRECT3DDEVICE8);
//	HRESULT		Render(LPDIRECT3DDEVICE8,D3DXMATRIX*,
//			D3DXMATRIX*);
//	BOOL		Save(char *filename);				// Save the file to the specififed file. If it exists
//									// it will be overwritten. If not, it will be created.
//	void		BuildLookAt(D3DXMATRIX	*matView);		// This is a wrapper for the MS version
//
//
//private:
//	HANDLE		mutex;						// gotta prevent display thread, (main thread) and 
//									// handler thread from simultaneously accessing
//	CWinTimer	simtime;					// 
//	CWinTimer	updatetime;					// 
//	BOOL		pgup;						// the look up key
//	BOOL		pgdn;						// the look dn key
//	BOOL		ins;						// the move up key
//	BOOL		del;						// the move dn key
//	BOOL		uparrow;					// the move forward key
//	BOOL		dnarrow;					// the move backward key
//	BOOL		leftarrow;					// the turn left key
//	BOOL		rightarrow;					// the right key
//
//	CIndex		*xindex;					// an index to CRooms, sorted on xpos
//									// this is the only access to room objects
//	CRegion		*fastregions[NUMFASTREGIONS];			// The close by regions. This list gets updated on a move.
//	CRegion		*regions;					// The region list
//	CInode		*movers;					// a list of models to use for movers
//	CRoom		*rooms;						// All rooms in the world. The nextroom pointer
//									// is simply for list maint, the chars go through the 
//									// portal array of pointers
//	D3DXMATRIX	matworld;					// This is really just a dummy matrix,
//									// saying that the world is at 0,0,0 :)
//	D3DXVECTOR3	vEyePt;
//	D3DXVECTOR3	vLookAtPt;
//	D3DXVECTOR3	vUp;
//	BOOL		(*treeadd)(char *,HWND hwndTV, int n,LPARAM p);	// A function to add entries to the tree 
//	HWND		hwndtv;						// control display (if present)
//	CHARSTATES	movingchars[MAXNUMOFVISIBLECHARS];		// This array holds the state of all VISIBLE moving things
//	BOOL		inside;						// whether to use the outside or inside renderer
//	};
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// CInode class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CInode 
{

//friend class CWorld;       //allows the CWorld class to get inside
friend class CModel;       //allows the CWorld class to get inside

public:
				CInode();			// Init pointers
				~CInode();

private:

	CModel		*model;		// either model or portal is used, not both at the same 
	CPortal		*portal;	// time. Just using the same Inode for two lists
	CInode		*nextnode;	// of different classes of objects
	};

///////////////////////////////////////////////////////////////////////////////////////////////////
// CRegion class
///////////////////////////////////////////////////////////////////////////////////////////////////
//class CRegion 
//{
//
//friend class CWorld;       //allows the CWorld class to get inside
//
//public:
//		CRegion();			// Init pointers
//		~CRegion();
//	void	SetIndex(int,int,int);		// Sets the index location for the region
//
//private:
//
//	int      x;
//	int      y;
//	int      z;
//	CRegion	*nextregion;			// next region in CWorld region list
//	CInode	*nextmodelnode;			// beginning of cmodel list for movers
//	CPortal	*nextportalnode;		// beginning of cportal list
//
//	};
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// CModel class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CModel 
{

//friend class CWorld;       //allows the CWorld class to get inside

public:
				CModel();			// Init pointers
				~CModel();

	BOOL			Init();				// sets pointers into data struct;
//	BOOL			Init(BOOL (*pfunc)(char *,HWND,int,LPARAM),
//						HWND);		// sets pointers into data struct;
									// sets size;
	void			SetFileName(const char*);	// DEBUG!!!!
	BOOL			InsertPart(CPart*);		// Given existing CPart insert in front 
								// of this Cmodel
	BOOL			Load(char *filename,
					float,float,float,	// the mat world will be stored with the model
					float,float,float,	// load the model from the specified file
					int level);		// The level in the tree add
//	HRESULT			InitDeviceObjects(LPDIRECT3DDEVICE8 );
//	HRESULT			Destroy();
//	HRESULT			InvalidateDeviceObjects();
//	HRESULT			RestoreDeviceObjects(LPDIRECT3DDEVICE8);
	int			Render();
//	HRESULT			Render(LPDIRECT3DDEVICE8,
//					D3DXMATRIX*,
//					D3DXMATRIX*,
//					D3DXMATRIX*);		// each cmodel should have its own matworld matrix
//	BOOL			Save(char *filename);		// Save the file to the specififed 
	BOOL			Save();				// Save the file to the specififed 
								// file. If it exists
								// it will be overwritten. 
								// If not, it will be created.

private:
	float			xpos;				// offset from origin for this model
	float			ypos;
	float			zpos;					
	float			roll;				// offset from origin for this model
	float			pitch;
	float			yaw;					
	CString			myfilename;			// the models data file name
	CInode			*sublist;			// points to list of submodels
	CPart			*partlist;			// points to list of parts


//	BOOL			(*treeadd)(char *,HWND hwndTV,int n,LPARAM p);	// A function to add entries to the tree 
//	HWND			hwndtv;					// control display (if present)

//	D3DXMATRIX		matworld;			// The matworld matrix for each model gets stored with model
	VECT			*pos;				// these have been moved in from cworld, they should stay with 
	VECT			*rot;				// their owm model
	};

///////////////////////////////////////////////////////////////////////////////////////////////////
// CList class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CList
{

public:
				CList();			// Init pointers
				~CList();
	
	BOOL			Init();				// sets pointers into data struct;
								// sets size;
	BOOL			Load(FILE *f,			// load vertex lists
				char*,int);
	BOOL			Save(FILE *f);
	int			Render();
	int			GetIndexCount();
	int			GetVertexCount();
	int			GetListType();
	int			GetTriCount();
	BOOL			GetVertex(MODVECT *v,int i);
	BOOL			SetVertex(MODVECT *v,int i);
	BOOL			GetIndex(unsigned int *w);

private:
	int			CreateTexture(CString *texturename);

	int			listtype;			// what kind of list is this ?
	int			vertcount;			// how verticies
	int			indcount;			// how indecies
	int			tricount;			// how indecies

	char			*texturename;		// texture names
	GLuint			*texture;		// texture vars
	MODVECT			*vertex;		// Points to array of vertecies
	unsigned int		*index;	
//	LPDIRECT3DVERTEXBUFFER8	pVB;			// 
//	LPDIRECT3DINDEXBUFFER8	pIB;

	};


///////////////////////////////////////////////////////////////////////////////////////////////////
// CPart class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CPart
{

//friend class CWorld;
friend class CModel;

public:
			CPart();			// Init pointers
			~CPart();

	BOOL		Init();				// sets pointers into data struct;
							// sets size;
	BOOL		InsertList(CList *l);		// Insert a given list at next frame index 
	BOOL		InsertList(CList *l,int i);	// Insert a given list at frame index i
	BOOL		Load(FILE *f, char*,int);
	BOOL		Save(FILE *f);
	int		Render();			// each cmodel should have its own matworld matrix
	void		Destroy();			// maybe we do want a destroy
private:
	int		framecount;			// how many frames to render for animation
	CList		*list[MAXFRAMECOUNT];		// An array pointers to CList
	CPart		*nextpart;			// points to list of parts
	};

///////////////////////////////////////////////////////////////////////////////////////////////////
// CPortal class
///////////////////////////////////////////////////////////////////////////////////////////////////
//class CPortal
//{
//
//friend class CWorld;
//friend class CRoom;
//public:
//				CPortal();			// Init pointers
//				~CPortal();
//
//private:
//	long			roomid;				// this is the objid of the room we are linking to
//								// this is a one way link, to be able to come back
//								// the other room must have a link to this room
//	CModel			*model;				// This is the model that represents the 
//								// portal for rendering purposes,
//								// with submodels and animation et al
//	float			dist;				// When with in this distance to portal
//								// char is going into the portal
//	CRoom			*room;				//
//	CString			modelfilename;			// The filename of the model for the portal
//	CPortal			*nextportal;			// Pointer to next  in linked list of portals
//	CString			portalname;			// the name of the portal
//	CString			portalfilename;			// the name of the portal
//	BOOL			open;				// Can chars get through the portal ?
//	BOOL 			translucent;			// Can chars see through the portal ?
//	};

///////////////////////////////////////////////////////////////////////////////////////////////////
// CRoom class
///////////////////////////////////////////////////////////////////////////////////////////////////
//class CRoom
//{
//
//friend class CWorld;
//
//public:
//				CRoom();			// Init pointers
//				~CRoom();
//
//	BOOL			Init();				// sets pointers into data struct;
//								// sets size;
//	BOOL			InsertRoom(CRoom *r);		// Insert a given room at beginning of the list 
//	BOOL			InsertRoom(CRoom *r,CRoom *pr);	// Insert a given room after the given room 
//
//private:
//	long			roomid;				// OBJID, same as used for other objects,
//								// this implies that rooms have representations (CModels)
//								// Just like anything else
//	float			xpos;
//	float			ypos;
//	float			zpos;
//	float			pitch;				// Can you tell i was a pilot once ?
//	float			roll;				// rotations about various axes
//	float			yaw;
//	CModel			*model;				// This is the model that represents the 
//								// room for rendering purposes,
//								// with submodels and animation et al
//	CString			modelfilename;			// The filename of the model for the room
//	CPortal			portals[MAXPORTALS];		// Array of doors or windows to other rooms
//								// Through which things can be seen
//								// or through which chars can try to pass.
//	CString			roomname;			// The name of the room itself
//	CString			roomfilename;			// The filename of the room itself
//	};
//
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// CIndex class
///////////////////////////////////////////////////////////////////////////////////////////////////
//class CIndex
//{
//
//friend class CWorld;
//
//public:
//				CIndex();			// Init pointers
//				~CIndex();
//
//	BOOL			Init();				// sets pointers into data struct;
//								// sets size;
//	BOOL			InsertRoom(CRoom *r);		// Insert a given room at beginning of the list 
//
//private:
//	CRoom			*rooms[MAXROOMS];				// array of pointers to CRoom objects
//	long			roomcount;			// how many rooms are there
//	long			allocated;			// how many index slots have been allocated
//	};
//
#endif //_CWORLD_HPP_

