///////////////////////////////////////////////////////////////////////////////////////////////////
// Client and modeler NEW VERSION
// cinode.hpp : This class can
// read in from file the description list of models that comprise the world
// save world state to file
// render world (collection of models) to screen
//	with animation
// 
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 07 Mar 2004
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact:
//		email	worldii@viagloria.com
//		web		www.viagloria.com
//
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(_CINODE_HPP_)  //skip this stuff if it has already been seen
#define _CINODE_HPP_        //by the compiler

///////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "wiii_types.h"
#include "wiii_structures.h"
#include "worldiii.h"
#include <GL/gl.h>
#include <GL/glu.h>
//#include "cworld.hpp"

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// CInode class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CRegion;

class CModInode 
{

friend class CWorld;       //allows the CWorld class to get inside
friend class CModel;       //allows the CWorld class to get inside

public:
				CModInode();			// Init pointers
				~CModInode();
	void		SetTrans(
				GLfloat,
				GLfloat,
				GLfloat
				);
	void		SetRot(
				GLfloat,
				GLfloat,
				GLfloat
				);


private:

	CModel		*model;		// either model or portal is used, not both at the same 
//	CPortal		*portal;	// time. Just using the same Inode for two lists
	CModInode		*next;		// of different classes of objects
	CModInode		*prev;		// of different classes of objects

	GLfloat		xpos;
	GLfloat		ypos;
	GLfloat		zpos;
	GLfloat		roll;
	GLfloat		pitch;
	GLfloat		yaw;
	};

///////////////////////////////////////////////////////////////////////////////////////////////////
// CRegInode class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CRegInode 
{
friend class CWorld;
friend class CRegion;

public:
				CRegInode();
				~CRegInode();
	void		SetPos(
				GLuint,		// xlocation
				GLuint,		// ylocation
				GLuint		// zlocation
				);

private:
	CRegion		region;		// the region we're poiting to
	CRegInode	*next;		// 
	CRegInode	*prev;		// 


	};


#endif //_CINODE_HPP_

