///////////////////////////////////////////////////////////////////////////////////////////////////
// Client and modeler NEW VERSION
// clist.hpp : These classes can
// read in from file the description list of models that comprise the world
// save world state to file render world (collection of models) to screen
//	with animation
// 
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 24 Feb 2004
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact:
//		email	worldii@viagloria.com
//		web		www.viagloria.com
//
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// The CWorld Class will start to be come more of a real rendering engine.
// It will be where 
//	- keyboard input is taken
//	- where the scene is rendered
//	- where simulation is done
//	- where preculling based on 
//		- visibility
//		- region 
//		- whether inside something or not is done.
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(_CLIST_HPP_)  //skip this stuff if it has already been seen
#define _CLIST_HPP_        //by the compiler

///////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////////////////////////
#include <GL/gl.h>
#include <GL/glu.h>
#include "SDL.h"
#include "wiii_types.h"
#include "wiii_structures.h"
#include "worldiii.h"
#include "cstring.hpp"
#include "cmodel.hpp"

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
///////////////////////////////////////////////////////////////////////////////////////////////////
//class CPart;
//#define 	CW_OK				0	// the operation completed successfully
//#define		CW_ERR_FILE_OPEN		1	// File open failed 
//#define		CW_ERR_CONVERSION		2	// File fscanf failed 
//#define		CW_ERR_TEXLOAD			3	// Image load failed 
//#define		CW_ERR_RENDER			4	// Render failed 

///////////////////////////////////////////////////////////////////////////////////////////////////
// CList class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CList 
{


public:
				CList();			// Init pointers
				~CList();

	BOOL			Init();				// sets pointers into data struct;
	int			Load(FILE *f, int level);	// The level in the tree add
	int			Destroy();
	int			Render();
	BOOL			Save(FILE *f);				// Save the file to the specififed 

private:
	VECT			*pos;				// moved in from cworld, they should stay with 
	VECT			*rot;				// their owm model
	MODVECT 		*list;				// all the vertices and their data
	GLuint			texture;			// this will turn into an array of texture names
	SDL_Surface		*TextureImage;			// load image
	int			tricount;
	int			vertcount;
	int			dontknow;

	};

#endif //_CLIST_HPP_

