///////////////////////////////////////////////////////////////////////////////////////////////////
// Client and modeler NEW VERSION
// cpart.hpp : These classes can
// THe reason we have CList is to have a basic component, a hand or arm or some such,
// CPart allows us to put many lists together for a crude form of animation.
// save world state to file render world (collection of models) to screen
//	with animation
// 
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 24 Feb 2004
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Contact:
//		email	worldii@viagloria.com
//		web		www.viagloria.com
//
///////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined(_CPART_HPP_)  //skip this stuff if it has already been seen
#define _CPART_HPP_        //by the compiler

///////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////////////////////////
#include <GL/gl.h>
#include <GL/glu.h>
#include "SDL.h"
#include "wiii_types.h"
#include "wiii_structures.h"
#include "worldiii.h"
#include "cmodel.hpp"

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
///////////////////////////////////////////////////////////////////////////////////////////////////

class CList;
  
///////////////////////////////////////////////////////////////////////////////////////////////////
// CPart class
///////////////////////////////////////////////////////////////////////////////////////////////////
class CPart
{

//friend class CWorld;
friend class CModel;

public:
			CPart();			// Init pointers
			~CPart();

	BOOL		Init();				// sets pointers into data struct;
							// sets size;
	BOOL		InsertList(CList *l);		// Insert a given list at next frame index 
	BOOL		InsertList(CList *l,int i);	// Insert a given list at frame index i
	BOOL		Load(FILE *f, int);
	BOOL		Save(FILE *f);
	int		Render();			// each cmodel should have its own matworld matrix
	int		Destroy();			// maybe we do want a destroy

private:
	int		framecount;			// how many frames to render for animation
	CList		*list[MAXFRAMECOUNT];		// An array pointers to CList
	CPart		*nextpart;			// points to list of parts
	};

#endif //_CPART_HPP_

