////////////////////////////////////////////////////////////////////////////////////////////////////
// portmon.cpp -- This is it.
// This is the portmon thread code for the client.
//
// World III
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 31 Jan 2006
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////

 
////////////////////////////////////////////////////////////////////////////////////////////////////
// Include
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#include "cworld.hpp"
#include "cusock.hpp"
#include "wiii_util.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Define
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Globals
////////////////////////////////////////////////////////////////////////////////////////////////////

// constant used for converting to radians 
const float piover180 = 0.0174532925f;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Externals
////////////////////////////////////////////////////////////////////////////////////////////////////
extern int	loglevel;

////////////////////////////////////////////////////////////////////////////////////////////////////
// Code
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// PortMon
////////////////////////////////////////////////////////////////////////////////////////////////////
void *PortMon(void *ptr)
{
int             count;
char            *mesg;                  // the protocol will give me a buffer with a packet in it
char            buf[80];
CWorld          *w;
CUSock		*s;
//CString		cs;

	// unpack the integer parameter that points to our structure in serverlist
//	LockPrint("Portmon: Entering Portmon\n");
	w=(CWorld*)ptr;
	s=w->GetSock();
	while (1)
	{
		count=s->Recv(&mesg, 0);

		// Got something, print it
		if (count>0)
		{
//			cs.SetString(mesg);
//			w->InsertLine(&cs);
			w->InsertLine(mesg);
			printf("INCOMING message \n");
			printf(mesg);
			printf("=end message \n");
			delete [] mesg;
			}
		} // end while loop

	s->Close();

//	LockPrint("EXITING PORTMON THREAD===>>>>>\n");
	return (0);
	} ///////////////////////////////////////////////////////////////////////////////end PortMon




