////////////////////////////////////////////////////////////////////////////////////////////////////
// Console
// portmon.cpp -- monitors the port talking to the client
//
// Portmonitor module
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 28 Jun 2006
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <sys/socket.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <errno.h>
#include <stdio.h>
#include <curses.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

//#include "wiii_types.h"
#include "wiii_curses.h"
#include "cusock.hpp"
#include "wiii_util.h"
#include "assert.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Globals
////////////////////////////////////////////////////////////////////////////////////////////////////
extern char logfilename[];
extern CUSock *consock;
extern bool  keepmon;

////////////////////////////////////////////////////////////////////////////////////////////////////
// Local Globals
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// PortMon
//
// timedout==false                                      timedout=true
//      code==0						Nothing else matters
//           count==0 = > close
//
//           count!=0 = > data length
//
//      code!=0
//           count doesnt matter
//           code < 0 socket error
//           code > 0 select error
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void *PortMon(void *ptr)
{
int 		count;
char		*mesg;                  // the protocol will give me a buffer with a packet in it
curswin		*p;

	// log startup of thread
	ThreadLog("PortMon: Entered.\n");

	// unpack parms
	p=(curswin *)ptr;
	MyPrint(p->debugwin,"Portmon: Entering Portmon\n", false);
	// init loop flag
	keepmon=true;

	while (keepmon)
	{
		count=consock->Recv(&mesg, 0);

		// Got something, print it
		if (count>0)
		{
//			mesg[count-1]=0;
			MyPrint(p->mainwin,mesg,true);
			delete [] mesg;
			}
		} // end while loop

//	consock->Close();

	MyPrint(p->debugwin,"EXITING PORTMON THREAD===>>>>>",true);
	ThreadLog("PortMon: Exit.\n");
	return (0);
	} ///////////////////////////////////////////////////////////////////////////////end Portmon

