////////////////////////////////////////////////////////////////////////////////////////////////////
// cgnomewin.hpp 
// This is the class defs for the graphical console. Writing a gnome app.
//
// World III
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 13 Sep 2007
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
////////////////////////////////////////////////////////////////////////////////////////////////////
#define		MAXSYMTAB		20

////////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <gtkmm.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>

#ifndef _CGNOMEWIN_HPP_
#define _CGNOMEWIN_HPP_
#include "cstring.hpp"
#include "wiii_structures.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// CGnomeWin
////////////////////////////////////////////////////////////////////////////////////////////////////
class CGnomeWin : public Gtk::Window
{
public:
					// Constructor / destructor
					CGnomeWin();
	virtual				~CGnomeWin();

protected:
					// Child widgets
	Gtk::VBox 			m_Box;
	Gtk::VBox			m_VBox;
					// Signal handlers
	virtual void			OnMenuFileNewGeneric();
	virtual void			OnMenuFileQuit();
	virtual void			OnMenuOthers();

	virtual void			OnMenuChoicesOne();
	virtual void			OnMenuChoicesTwo();
	
	// Test Menu
	virtual void			OnMenuShowServers();
	virtual void			OnMenuPingServer();
	virtual void			OnMenuDebugLevel();
	virtual void			OnMenuDebugLevel1();

	// Server Menu
	virtual void			OnMenuConnectServer();
	virtual void			OnMenuDisconnectServer();
	virtual void			OnMenuStartServer();
	virtual void			OnMenuStopServer();
	virtual void			OnMenuStartListening();
	virtual void			OnMenuStopListening();

	// Communicate Menu
	virtual void			OnMenuListClients();
	virtual void			OnMenuSearchClient();
	virtual void			OnMenuSendSingleClient();
	virtual void			OnMenuSendGroupClients();
	virtual void			OnMenuSendAllClients();
	virtual void			OnMenuSessionWithClient();

	// Buttons
	virtual void			OnButtonQuit();
	virtual void			OnStartButton();
	virtual void			OnStopButton();
	virtual void 			OnNotebookSwitchPage(
						GtkNotebookPage* page, 
						guint page_num);
	 	
	// Make Note Book
	void 				MakeNoteBookP1();
	void 				MakeNoteBookP2();
	void 				MakeNoteBookP3();

	void				MakeMenu();
	void				MakeNoteBook();


	// Main page stuff
	Glib::RefPtr<Gtk::UIManager>	uimgr;
	Glib::RefPtr<Gtk::ActionGroup>	actiongroup;
	Glib::RefPtr<Gtk::RadioAction>	choiceone,choicetwo;
	Gtk::Button 			m_Button_Quit;
	Gtk::HButtonBox 		m_ButtonBox;

	// Note book stuff
//	Gtk::HBox			m_HBox;
	Gtk::VBox			vbox1;
	Gtk::HBox			hbox1,hbox2,hbox3;
	Gtk::Notebook 			m_Notebook;
	Gtk::Label 			connectlabel, m_Label2, m_Label3;

	Gtk::Button 			startbutton, stopbutton;	// These two stop and start the services
									// on the server machine
	Gtk::Button			connectbutton,disconbutton;
	Gtk::Button			listenbutton,stoplistenbutton;	
	Gtk::HButtonBox 		startbuttonbox,stopbuttonbox;
	Gtk::HButtonBox 		connectbuttonbox,disconbuttonbox;
	Gtk::HButtonBox 		listenbuttonbox,stoplistenbuttonbox;
			
	Gtk::Entry			servertextbox;			// This is which server we're talking to
	};

#endif //_CGNOMEWIN_HPP_


