////////////////////////////////////////////////////////////////////////////////////////////////////
// cfont.hpp -- This is it.
// This is the font module for the first real attempt to put together my 3d world game.
//
// World III
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 26 Jan 2006
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
//  This draws from example code by Jeff Molofee '99
//  (ported to Linux/SDL by Ti Leggett '01)
//
//  Jeff Molofee: Yes i did find it useful :) Thanks !
//
//  Visit Jeff at http://nehe.gamedev.net/
//
//  or for port-specific comments, questions, bugreports etc.
//  email to leggett@eecs.tulane.edu
////////////////////////////////////
// This also draws on example code by Sven Olsen 2003
// Also from the NeHe Site
// Thanks !!!
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <ft2build.h>
#include <freetype/freetype.h>
#include <freetype/ftglyph.h>
#include <freetype/ftoutln.h>
#include <freetype/fttrigon.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <string.h>
                                                                                                                                                             
#include "SDL.h"

#ifndef _CFONT_HPP_
#define _CFONT_HPP_
#include "client.h"
#include "cstring.hpp"
#include "wiii_util.h"

#define		CF_OK				0
#define		CF_ERR_LOADGLYPHFAILED		1
#define		CF_ERR_GETGLYPHFAILED		2
#define		CF_ERR_INITFREETYPEFAILED	3
#define		CF_ERR_NEWFACEFAILED		4

#define		CF_TYPE_INIT			0
#define		CF_TYPE_OLD			1
#define		CF_TYPE_TT			2
////////////////////////////////////////////////////////////////////////////////////////////////////
// CFont
////////////////////////////////////////////////////////////////////////////////////////////////////
class CFont
{
public:
	// Constructor / destructor
	CFont();
	~CFont();					// was called clean in example
	bool	BuildFont(CString *fontname);		// This creates the font. Use after default contruction.
	int	BuildTTFont(
			CString *fontname,
			int reqheight
			);				// This creates the font. Use after default contruction.
							// This was called init in the example
	void	SetLogFunc(
			void (*pfunc)(char*)
			);

	// 2D and 3D text drawing functions		// first overload
	bool	DrawTTText(GLint x, GLint y, 
			GLdouble width,
			GLdouble height,
			char *text);

	// 2D and 3D text drawing functions		// first overload
	bool	DrawTTText(GLint x, GLint y, 
			GLdouble width,
			GLdouble height,
			CString* text);

	// 2D and 3D text drawing functions		// first overload
	bool	DrawText(GLint x, GLint y, 
			GLdouble width,
			GLdouble height,
			CString* text);

	// 2D and 3D text drawing functions		// second overload
	bool	DrawText(GLint x, GLint y, 
			GLdouble width,
			GLdouble height,
			char* text);

	// 2D and 3D text drawing functions		// third overload
	bool	DrawText(float x, float y, 
			GLdouble width,			// may be unused	
			GLdouble height,		// may be unused	
			char* text);

	bool	SetTexture(char *t);

private:
	inline void PushScreenCoordinateMatrix();
	inline void PopProjectionMatrix();


	int	fonttype;				// which type of font is being used
	int 	MakeDisplayList( 
			FT_Face face, 
			char ch, 
			GLuint list_base, 
			GLuint * tex_base 
			);
	bool	DrawTTTextInt(
			GLint x, GLint y,
			GLdouble width,
			GLdouble height,
                        char* text
			);
	bool	DrawTextInt(
			GLint x, GLint y,
                        GLdouble width,
                        GLdouble height,
                        char* text
			);
	void		ProtLog(char *s);
	void		(*LogFunc)(char *s);
	CString		fontname;		// Font properties
	GLuint		base;			// Base Display List For The Font Set 
	GLuint		texture;		// this will turn into an array of texture names
	SDL_Surface	*TextureImage;		// load image
//////////////////////////////////////////////////
//	float 		h;			// height of the font
	int 		h;			// height of the font
	GLuint		*textures;		// texture ids
	GLuint		list_base;		// holds the first display list id
	
	
	};




#endif //_CFONT_HPP_


