/////////////////////////////////////////////////////////////////////////////////////
// cmessage.hpp
// This class will construct & manage messages 
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jan 2006
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
/////////////////////////////////////////////////////////////////////////////////////
#if !defined(_CMESSAGE_HPP_)  //skip this stuff if it has already been seen
#define _CMESSAGE_HPP_        //by the compiler

/////////////////////////////////////////////////////////////////////////////////////
// Includes
/////////////////////////////////////////////////////////////////////////////////////
//#include "wiii_types.h"
#include "worldiii.h"
#include "wiii_structures.h"
#include "cstring.hpp"

/////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
/////////////////////////////////////////////////////////////////////////////////////
#define         ERRORITEMCOUNT		5	// 

#define         CMSG_NOERROR		0	// 
#define         CMSG_CMDUNRQ		1	// 
#define         CMSG_PARMCNT		2	// 
#define         CMSG_NOMSG		3	// 
#define         CMSG_UNKERR		4	// 

#define         CMSG_NOERROR_T		"No error."	
#define         CMSG_CMDUNRQ_T		"Command Unrecognized."	
#define         CMSG_PARMCNT_T		"Command Parm Count Wrong."	
#define         CMSG_NOMSG_T		"Attempted to get error info with invalid msg ptr."	
#define         CMSG_UNKERR_T		"Error message wrong. Please report as a bug."	

/////////////////////////////////////////////////////////////////////////////////////
// CMessage class
// this will simply be a place to store a messgage
/////////////////////////////////////////////////////////////////////////////////////
class CMessage 
{
//friend class CMQueue;
public:
			CMessage();
			~CMessage();
	int		GetMessage();			// get message
	void		SetMessage(int);		// set message value
	void		SetErrorType(int);		// set message error type
	int		GetErrorType();			// set message error type
	void		SetUnhandled();			// set message as an unhandled string
	void		SetParm(int);			// set parm
	char		*GetParm(int i);		// get parm
	CString		*GetParmCS(int i);		// get parm
	posup		*GetPosup();			// get parm
	int		GetParmCount();			// get parmcount
	bool		AddParmToMsg(	int p, 		// copies from string given
					int tp, 	// and creates parm
					char *c);
	bool		GetPlayerChar(pctype *p,int i);	// fills the array at index i

	bool		CheckMessage();			// checks message to ensure
							// it has proper number of params
	void		ClassStaticInit();		// HACK, this will need to be called 
							// ONCE ONLY, to init the class
							// static array
	bool		CheckProperCmd(	int p,		// check to see if it is a proper
					int tp,		// cmd, if so, sets the msg member
					char *rawbuf);	// else returns false and does nothing


private:

static	int		count;				// how many commands
static	cmdtype         cmdarray[CMDARRAYSIZE];		// An Array containing all legal commands
static	CString		locallogfile;			// set this during Init
static	CString		*errorarray;			// set this during Init

	int		msg;
	CString		*parm[MAXMESSAGEPARMS];		// An array of pointers to CStrings
	int		nextparm;			// the next parm to assign
	CMessage	*nextmsg;
	CMessage	*prevmsg;
	int		errortype;
	};

#endif //_CMESSAGE_HPP_
