/////////////////////////////////////////////////////////////////////////////////////
// cthread.hpp
// This class will implement a thread managment class 
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jan  2006
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
/////////////////////////////////////////////////////////////////////////////////////
#if !defined(_CTHREAD_HPP_)  //skip this stuff if it has already been seen
#define _CTHREAD_HPP_        //by the compiler

/////////////////////////////////////////////////////////////////////////////////////
// Includes
/////////////////////////////////////////////////////////////////////////////////////
#include "worldiii.h"
//#include "wiii_types.h"

/////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
// CThreadList class
/////////////////////////////////////////////////////////////////////////////////////
class CThreadList
{
public:
		CThreadList();
		~CThreadList();
	bool	Init();	    			     	// to have a non fail constructor, 
        int     StartThread(void *func(void *),void *); // to create & start a thread
        int     PauseThread();  		 	// to suspend a thread
        int     TermThread();         		 	// to ask a thread to end itself
        int     KillThread();        		  	// to kill a thread forcibly

private:
//        int     GetTCount(){return(tcount);}; 	
//        int     IncTCount(){return(tcount++);}; 
//static	int		tcount;				// this counts the threads & points
							// to the next thread
	pthread_t	threadlist[MAXTHREADS];  	// list of threads

	};

#endif //_CTHREAD_HPP_
