/////////////////////////////////////////////////////////////////////////////////////
// wiii_util.h
// Include file to access various util functions 
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 22 May 2007
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
// Includes
/////////////////////////////////////////////////////////////////////////////////////

#if !defined(_WIII_UTIL_H_)  //skip this stuff if it has already been seen
#define _WIII_UTIL_H_        //by the compiler
#include "cstring.hpp"
#include "cengine.hpp"
#include "wiii_structures.h"

extern	int	MyLog(char * s, char * log);
extern	void	ThreadLog(char * s);
extern	void	ThreadLog(CString * s);
extern	int	MyLock  (pthread_mutex_t *mutex, bool MyP, char * who);
extern	int	MyReadLock(pthread_rwlock_t *rwlock, bool MyP, char * who);
extern	int	MyWriteLock(pthread_rwlock_t *rwlock, bool MyP, char * who);
extern	int	MyTryWriteLock(pthread_rwlock_t *rwlock, bool MyP, char * who);
extern	int	MyRWUnLock(pthread_rwlock_t *rwlock, bool MyP, char * who);
extern	int	MyUnLock(pthread_mutex_t * mutex, bool MyP, char * who);
extern	int	CopyStrip(char *dest, const char *src, const char *delim, size_t n);
extern	void	PError(int);
extern	void	InitMutex(pthread_mutex_t *mutex);
extern	void	InitRWLock(pthread_rwlock_t *rwlock);
extern	int	CreateThread(pthread_t  *thread, void *(*start_routine)(void *), void *arg);
extern	CString *GetAFileName(curswin*);
extern	CString *GetAString(curswin*);
extern	int	NextPowerOfTwo(int  a);
extern	int	MyPrint(WINDOW *w, char *s, bool wait);
extern	int	MyPrint(WINDOW *w, CString *s, bool wait);
extern	bool	LoadFile(CString *filename, CEngine *e);

#endif //_UTIL_H_

#ifdef SOLARIS
extern void	pthread_yield();
#endif



