////////////////////////////////////////////////////////////////////////////////////////////////////
// worldiii.h App Specific Constants
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci
// Revised : 26 Jan 2006
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef   _WORLDIII_H_
#define   _WORLDIII_H_
        
#define MAXNUMOFVISIBLECHARS		30			// VISIBLE things the client simulates, 
#define LOGFILENAMELEN			100			// Path & name len of log file per thread 
#define MAX_LOADSTRING			100
#define MESSAGE_BOX_DISP_SIZE		10			// How many lines are displayed at once
#define MESSAGE_BOX_SIZE		100			// Number of lines in the client screen buffer
#define MESSAGE_BOX_LINE_LEN		30			// Number of lines in the client screen buffer
#define MAXQRAWBUF			100			// The maximum CRawBuf queue size
#define MAXQMQUEUE			100			// The maximum CMQqeue queue size
#define MAXSERVERS			100			// Maximum number of servers and or ports to use
#define MAXMESSAGEPARMS			11			// Maximum number of parms per message
#define INVALIDSERVER			0			// We are just saying that the curs is not in use
#define NUM_START_CURSORS		2*MAXSERVERS		// The number of cursors to create at startup
#define MAXCURSORS			5*MAXSERVERS		// The maximum number of cursors to allow
#define INVALIDCURSOR			MAXCURSORS+1		// A magic number for an INVALID CURSOR
#define MAXLISTS			5*MAXSERVERS		// the number of lists in the object structure
#define MAXTHREADS			3*MAXSERVERS+10		// Maximum number of servers and or ports to use
#define CONWORLDPORT			3999
#define BASEWORLDPORT			4000
#define MAX_PENDING_CONNECTS		4			// The backlog allowed for listen() 
#define NO_FLAGS_SET			0			// Used with recv()/send()          
#define MY_MSG_LENGTH			80			// msg buffer sent back and forth   
#define MAXSTARTWAIT			20000			// The amount of time to wait for a new
								// server instance to start (20 seconds)
//#define INVALIDCURSOR			MAXCURSORS+1		// A magic number for an INVALID SERVER
#define WORLDMSGSIZE			1500			// The total size of a socket msg	
#define WORLDPARMSIZE			70			// Max amount of space for parms in a socket msg
#define MAXNAMELENGTH			20			// The max amount of space for userid
#define MAXATTRLENGTH			20			// The max amount of space for attribute
#define MAXOFKEYTYPELEN			15			// The max amount of space for Object type fkey
#define PLAYERIDLENGTH			64			// The max amount of space for object id
#define UNSETSTRING			"UNSET"			// 
#define MAXCHARCOUNT			10			// The max number of characters a player can have
#define MAXFRAMECOUNT			8			// The max number of frame per part to animate 
#define MAXPARTS			20			// The max number of parts an object rep can have (for now)
#define MAXPORTALS			16			// Max number of portals out of any room (for now)
#define MAXROOMS			1000			// Max number of rooms 
#define MAXFILENAMELEN			100
#define REGIONSIZE			1000			// The size of display regions
#define VISIBLEX			100			// the x and y a z visibility distances
#define VISIBLEY			100			// 
#define VISIBLEZ			100			// 
#define NUMFASTREGIONS			27			// The number of regions to cache
#define NUMREGIONS			100			// The number of regions 
#define OBJIDTYPE			int
#define SAMPLE_BUFFER_SIZE		16			// arbitrary number of buffer elements
#define DATABASENAMELEN			80			// arbitrary number of buffer elements
#define PI				3.141592654f
#define BUFFSIZE			120			// for buffers to do logging with

////////////////////////////////////////////////////////////////////////////////////////////////////
// Clientmodes
// State
//	0->1
//	1->0,2,3,5
//	2->0,4,5,6,7
//	3->0,5,0
//	4->0,2
//	5->0,Prev state
//	6->0,2,9
//	7->0,9
//	8->0,?
//	9->0,2
////////////////////////////////////////////////////////////////////////////////////////////////////
#define	CLM_NOTCONNECTED	0		// When client starts
#define	CLM_CONNECTED		1		// After Connect succesful, 
#define	CLM_LOGGEDIN		2		// After Logged in
#define	CLM_ACCTREQ		3		// Wants to request account
#define	CLM_ACCTMAINT		4		// Maintain account, and delete account
#define	CLM_CONTACT		5		// Contact WM World Master
#define	CLM_CHARMAINT		6		// Create and delete char
#define	CLM_CHARSELECT		7		// Select char to play
#define	CLM_LOBBY		8		// ?
#define	CLM_PLAY		9		// Player has joined the game

////////////////////////////////////////////////////////////////////////////////////////////////////
// Listtypes
////////////////////////////////////////////////////////////////////////////////////////////////////
#define	PLAYERLIST		0
#define	MOBLIST			1
#define	ITEMLIST		2
#define	ANIMALLIST		3
#define	LANDLIST		4

////////////////////////////////////////////////////////////////////////////////////////////////////
// Strings
////////////////////////////////////////////////////////////////////////////////////////////////////
#define SERVERSTARTTITLE        "WorldIII Server Initializing . . ."
#define SERVERWINDOWCLASS       "WORLDIIISERVERWINDCLASS"
#define SERVERCLIENTCONNECT     "WorldIII Server Process"

////////////////////////////////////////////////////////////////////////////////////////////////////
// WorldII Message Structures
////////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct 
{
	int		MsgType;
	int		TotalLength;  
	int		Command;
	int		ParmCount;
			// The variable length portion of 
			// the Command Message goes here		
     } CmdMsgType;

typedef struct
{
	int		ParmLen;	// This may expand in the future
	int		ParmType;	// This may expand in the future
	} CmdParmType;

typedef struct 
{
	int		MsgType;
     int		TotalLength;  
	int		ParmCount;
	int		ObjSaid;
			// The variable length portion of 
			// the Command Message goes here		
     } UpdateMsgType;

typedef struct
{
	int		VTFkey;	// This is the VarTypeFKey
	char		Name[20];	// Name of the Attribute of the Object to Update
	char		Value[20];
	} UpdateParmType;


////////////////////////////////////////////////////////////////////////////////////////////////////
// App Specific Error Messages
////////////////////////////////////////////////////////////////////////////////////////////////////
#define ERR_NOERROR			0
#define ERR_BADHOSTNAME			1
#define ERR_SOCKCALLFAILED		2
#define ERR_BADIPORPORT			3
#define ERR_BINDCALLFAILURE		4
#define ERR_LISTENCALLFAILURE		5
#define ERR_ACCEPTCALLFAILURE		6
#define ERR_ONASYNCSELECTCALL		7
#define ERR_USERCANCEL			8
#define ERR_CONNECTCALLFAILURE		9
#define ERR_INVALIDSOCKET		10
#define ERR_GETHOSTPORT			11
#define ERR_SERVNOTFOUND		12
#define ERR_BADMESSAGE			13
#define ERR_UNHANDLEDMESSAGE		14
#define ERR_NOMORESERVERS		15
#define ERR_GETHOSTBYNAME		16
#define ERR_SOCKCREATE			17
#define ERR_SOCKCONNECT			18
#define ERR_SOCKSEND			19
#define ERR_SOCKRECV			20
#define ERR_NOTINIT			21
#define ERR_NOMEM_IN_RAWBUF		22
#define ERR_CANTSTARTTHREAD		23
#define ERR_TOOMANYTHREADS		24
#define ERR_NOTBOUND			25
#define ERR_NOTLISTEN			26
#define ERR_TOOMANYSERVERS		27
#define ERR_PLAYERNOTFOUND		28
#define ERR_INVALID_CURSOR		29
#define	ERR_MEDIANOTFOUND		30
#define	ERR_TOOMANYLISTS		31
#define	ERR_LIST_NOTINUSE		32
#define ERR_INVALIDSERVER		33
#define ERR_CURSOR_NOTINUSE		34

////////////////////////////////////////////////////////////////////////////////////////////////////
// App Specific Defines
// Listener
////////////////////////////////////////////////////////////////////////////////////////////////////
#define THREAD_ST_PAUSE			0
#define THREAD_ST_LISTEN		1

////////////////////////////////////////////////////////////////////////////////////////////////////
// App Specific Windows Messages
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
// Define Socket states
////////////////////////////////////////////////////////////////////////////////////////////////////
#define SOCK_ST_NOTINIT			0  // Not connected
#define SOCK_ST_INIT			1   // Port specified
#define SOCK_ST_CONNECTED		2   // Address specified & connected
#define SOCK_ST_BOUND			3   // Bound & ready to listen
#define SOCK_ST_LISTEN			4   // Listening
#define SOCK_ST_CLOSED			5   // Closed
#define SOCK_ST_CREATED			6   // Closed

////////////////////////////////////////////////////////////////////////////////////////////////////
// App Specific Sockets Message Types
////////////////////////////////////////////////////////////////////////////////////////////////////
#define MSG_TYPE_COMMAND		0
#define MSG_TYPE_UPDATE			1
#define MSG_TYPE_UPDATE_STATE		2
#define MSG_TYPE_MESSAGE		3

////////////////////////////////////////////////////////////////////////////////////////////////////
// App Specific Sockets Messages
////////////////////////////////////////////////////////////////////////////////////////////////////
#define MSG_RECONNECT			0
#define MSG_TERMCLIENT			1
#define MSG_SETTITTLE			2

////////////////////////////////////////////////////////////////////////////////////////////////////
// MESSAGE IDs
////////////////////////////////////////////////////////////////////////////////////////////////////
#define WIIIM_UNHANDLED		0x00000000	// This is an unrecognized string
#define WIIIM_NOMSG		0x00000001	// Attempted to get message errortype with no message
//#define WIIIM_OBJUPDATE		0x00000002	// may only send the specific attr to update
//#define WIIIM_OBJDELETE		0x00000003	// may only send the specific attr to update
//#define WIIIM_SESNSTART		0x00000004	// may only send the specific attr to update
//#define WIIIM_SESNSTOP		0x00000005		// may only send the specific attr to update
#define WIIIM_PING		0x00000006	
#define WIIIM_PORTCLOSED	0x00000007
#define WIIIM_FORCEDBREAK	0x00000008
#define WIIIM_PLAYERID		0x00000009
#define WIIIM_ACK		0x0000000A
#define WIIIM_ACCTREQ		0x0000000B
#define WIIIM_LOGOUT		0x0000000C
//#define WIIIM_NEWPLAYERID	0x0000000D	// to reuest a new id
#define WIIIM_SETMODE		0x0000000E	// to tell client what moed it is in
#define WIIIM_PLAYERCHAR	0x0000000F
#define WIIIM_CHARSELECT	0x00000010
#define WIIIM_PLAY		0x00000011
#define WIIIM_TURNLEFT		0x00000012
#define WIIIM_TURNRIGHT		0x00000013
//#define WIIIM_LOOKUP		0x00000014
//#define WIIIM_LOOKDN		0x00000015
#define WIIIM_LISTACTIVEPLAYERS	0x00000016
#define WIIIM_CLPRINT		0x00000017
#define WIIIM_PRI		0x00000018
#define WIIIM_LOCATION		0x00000019
#define WIIIM_SETPOS		0x0000001A	// from server to client to set client pos
#define WIIIM_FORWARD		0x0000001B
#define WIIIM_STOPMOVE		0x0000001C
#define WIIIM_BACKWARD		0x0000001D
#define WIIIM_STOPTURN		0x0000001E
#define WIIIM_SETMODEL		0x0000001F
#define	WIIIM_NEWPLAYER		0x00000020	// message sent to all other servers to force a SETMODEL
#define	WIIIM_SETSPEED		0x00000021	// client to server: set client's speed
#define	WIIIM_SETTRNSPD		0x00000022	// client to server: set client's turning speed
#define	WIIIM_SETDIR		0x00000023	// client to server: set client's direction
#define	WIIIM_SETPITCH		0x00000024	// client to server: set client's pitch
#define	WIIIM_TELL		0x00000025	// client to server: send a message to another player 
#define	WIIIM_TELLP		0x00000026	// client to server: send a message to another player 
#define	CMDARRAYSIZE		0x27		// This is a count of the number of commands
						// defined this way because WIIIM_ commands are counting up this way

////////////////////////////////////////////////////////////////////////////////////////////////////
// Primitive list types 
////////////////////////////////////////////////////////////////////////////////////////////////////
#define WII_PRIM_TRILIST	"[trilist]"
#define WII_PRIM_TRISTRIP	"[tristrip]"
#define WII_PRIM_TRIFAN		"[trifan]"

////////////////////////////////////////////////////////////////////////////////////////////////////
// TOKEN IDs
////////////////////////////////////////////////////////////////////////////////////////////////////
#define TOKEN_UNHANDLED		"anystring"	// This is just a placeholder
//#define TOKEN_BEGIN		"[begin]"
//#define TOKEN_END		"[end]"
#define CHAR_DELIM		'|'		// This is the delimiter
#define TOKEN_PING		"ping"		// sent to test basic comms between c & s
#define TOKEN_STAT		"stat"
#define TOKEN_CONNECT		"connect"
#define TOKEN_VERSION		"version"
#define TOKEN_CLPRINT		"clprint"	// directs clients to print following text
#define TOKEN_PRI		"pri"		// Sends a private message to a named player
#define TOKEN_LOCATION		"loc"		// Sends a request message for the location of player
#define TOKEN_PORTCLOSED	"portclosed"
#define TOKEN_PLAYERID		"playerid"	// followed by the login playerid
#define TOKEN_PLAY		"play"		// followed by index of selected char
#define TOKEN_PLAYERCHAR	"playerchar"
//#define TOKEN_LISTPLAYERS	"listplayers"
#define TOKEN_CHARSELECT	"charselect"
#define TOKEN_PASSWD		"passwd"	// used during login, followed by actual password
#define TOKEN_STOPTURN		"stopturn"
#define TOKEN_STOPMOVE		"stopmove"
#define TOKEN_LEFT		"left"
#define TOKEN_RIGHT		"right"
#define TOKEN_FORWARD		"forward"
#define TOKEN_BACKWARD		"backward"
#define TOKEN_FORCEDBREAK	"forcedbreak"
#define TOKEN_ACK		"ack"		// response sent to a ping
#define TOKEN_UPDATE            "update"
#define TOKEN_INSERT            "insert"
#define TOKEN_OBJID             "objid"
#define TOKEN_ATTR              "attr"
#define TOKEN_VAL               "val"
#define TOKEN_COMMAND           "command"
#define TOKEN_SETMODE           "setmode"
#define TOKEN_SETMODEL          "setmodel"
#define TOKEN_SETPOS            "setpos"	// Directs client to set character's postion
#define TOKEN_SETSPEED          "setspeed"		
#define TOKEN_SETTRNSPD         "settrnspd"		
#define TOKEN_SETDIR            "setdir"		
#define TOKEN_SETPITCH          "setpitch"		
#define TOKEN_NEWPLAYER         "newplayer"
#define TOKEN_ACCTREQ           "acctreq"	// used to request a new account
#define TOKEN_LISTACTIVEPLAYERS "listact"	// from client to server to send a list of players
#define TOKEN_LOGOUT            "logout"
#define TOKEN_CAMP              "camp"
#define TOKEN_LENGTH            "length"
#define TOKEN_VERTID            "vertid"
#define TOKEN_X                 "x"
#define TOKEN_Y                 "y"
#define TOKEN_Z                 "z"
#define TOKEN_EDGEID            "edgeid"
#define TOKEN_V1                "v1"
#define TOKEN_V2                "v2"
#define TOKEN_SURFID            "surfid"
#define TOKEN_E1                "e1"
#define TOKEN_E2                "e2"
#define TOKEN_E3                "e3"
#define TOKEN_E4                "e4"
#define TOKEN_E5                "e5"
#define TOKEN_REPID             "repid"
#define TOKEN_S1                "s1"
#define TOKEN_S2                "s2"
#define TOKEN_S3                "s3"
#define TOKEN_S4                "s4"
#define TOKEN_S5                "s5"
#define TOKEN_TELL		"tell"



////////////////////////////////////////////////////////////////////////////////////////////////////
// MESSAGE IDs
////////////////////////////////////////////////////////////////////////////////////////////////////
//#define RAW_MSG_FORCEDBREAK	"[begin][forcedbreak][end]\n"
//#define RAW_MSG_PORTCLOSED	"[begin][portclosed][end]\n"
#define RAW_MSG_FORCEDBREAK	"forcedbreak"
#define RAW_MSG_PORTCLOSED	"portclosed"


#define RAW_MSG_ACK		"[begin][ack][end]\n"


#endif
