/////////////////////////////////////////////////////////////////////////////////////
// csoil.cpp
// 
// by Eric J Krejci
// Copyright Eric J Krejci December 1999
// Revised : 16 Jan 2007
/////////////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <curses.h>
#include <pthread.h>
#include <unistd.h>
//#include <sys/socket.h>
//#include <netinet/in.h>
//#include <netdb.h>
#include "csoil.hpp"	   

/////////////////////////////////////////////////////////////////////////////////////
// Externals
/////////////////////////////////////////////////////////////////////////////////////
extern WINDOW * debugwin;
extern WINDOW * menuwin;
extern WINDOW * mainwin;

/////////////////////////////////////////////////////////////////////////////////////
// CSoil Constructor
/////////////////////////////////////////////////////////////////////////////////////
CSoil::CSoil()
{
     // do easy initialization
     nutrient=0;
     water=0;
     sun=0;	// the sun is much more predictable than mineral & water content
     pthread_mutex_init(&mutex, NULL);
     }////////////////////////////////////////////////////////////////end Constructor

/////////////////////////////////////////////////////////////////////////////////////
// CSoil Constructor
/////////////////////////////////////////////////////////////////////////////////////
void CSoil::Init()
{
     // do easy initialization
     nutrient=1+(int) (100.0*rand()/(RAND_MAX+1.0));
     water   =1+(int) (100.0*rand()/(RAND_MAX+1.0));
     sun=0;     // the sun is much more predictable than mineral & water content
     }////////////////////////////////////////////////////////////////end Constructor

/////////////////////////////////////////////////////////////////////////////////////
// CSoil Destructor
/////////////////////////////////////////////////////////////////////////////////////
CSoil::~CSoil()
{
     }/////////////////////////////////////////////////////////////////end Destructor

/////////////////////////////////////////////////////////////////////////////////////
// Lock
// Blocks until got the lock
/////////////////////////////////////////////////////////////////////////////////////
int CSoil::Lock()
{
     // lock the mutex
     return(pthread_mutex_lock(&mutex));
     } //////////////////////////////////////////////////////////////////////end Lock

/////////////////////////////////////////////////////////////////////////////////////
// UnLock
// returns immed after immed unlocking
/////////////////////////////////////////////////////////////////////////////////////
int CSoil::UnLock()
{
     // lock the mutex
     return(pthread_mutex_unlock(&mutex));
     } //////////////////////////////////////////////////////////////////////end Lock


/////////////////////////////////////////////////////////////////////////////////////
// GetNut
// returns the soil nutrients in the square meter under consideration
/////////////////////////////////////////////////////////////////////////////////////
int CSoil::GetNut()
{
     if (nutrient<0) nutrient=0;
     return(nutrient);
     } ////////////////////////////////////////////////////////////////////end GetNut

/////////////////////////////////////////////////////////////////////////////////////
// GetWater
// returns the soil nutrients in the square meter under consideration
/////////////////////////////////////////////////////////////////////////////////////
int CSoil::GetWater()
{
     if (water<0) water=0;
     return(water);
     } //////////////////////////////////////////////////////////////////end GetWater

/////////////////////////////////////////////////////////////////////////////////////
// GetSun
// returns the soil nutrients in the square meter under consideration
/////////////////////////////////////////////////////////////////////////////////////
int CSoil::GetSun()
{
     if (sun<0) sun=0;
     return(sun);
     } //////////////////////////////////////////////////////////////////end GetWater

/////////////////////////////////////////////////////////////////////////////////////
// SimEvap
// Simulates water evaporating from soil 
/////////////////////////////////////////////////////////////////////////////////////
int CSoil::SimEvap()
{

     Lock();
     // simulate the evap by taking difference between soil content > 20 
     // and by moving ten percent towards it each time
     if (water>20)
     {
          water=(int)(water-(water-20)*.1);
          }
     UnLock();
     } ///////////////////////////////////////////////////////////////////end SimEvap


