/////////////////////////////////////////////////////////////////////////////////////
// csoil.hpp
// This class will implement a message storage place 
// 
// by Eric J Krejci
// Copyright Eric J Krejci February 1999
// Revised : 24 Nov 2004
/////////////////////////////////////////////////////////////////////////////////////
#if !defined(_CSOIL_HPP_)  //skip this stuff if it has already been seen
#define _CSOIL_HPP_        //by the compiler

/////////////////////////////////////////////////////////////////////////////////////
// Includes
/////////////////////////////////////////////////////////////////////////////////////
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#include <pthread.h>

/////////////////////////////////////////////////////////////////////////////////////
// Defines
// These are class specific defines
/////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////
// Fixups
/////////////////////////////////////////////////////////////////////////////////////
#if !defined(FALSE)  // define FALSE if it is not already defined
#define FALSE 0
#endif                // define FALSE
#if !defined(TRUE)  // define TRUE if it is not already defined
#define TRUE !FALSE
#endif                // define TRUE

/////////////////////////////////////////////////////////////////////////////////////
// CSoil class
// this will simply be a place to store a page
/////////////////////////////////////////////////////////////////////////////////////
class CSoil
{
public:
		CSoil();
		~CSoil();
	void	Init();
	int	Lock();
	int	UnLock();
	int	GetNut();
	int	GetWater();
	int	GetSun();
	int	SimEvap();			// simulate evaporation to soil stadard of20

private:
	int			seed;		// this will be continually updated
	int			nutrient;	// how vitamins & minerals
	int			water;		// how much moisture
	int			sun;		// how much sun this square meter 
               					// of land is getting now
 	pthread_mutex_t 	mutex; 
	};

#endif //_CSOIL_HPP_

