          ARCHDIR = i386-redhat-linux
          PRODDIR = 2.8.1
           GNUDIR = /usr/local
               CC = $(GNUDIR)/bin/g++

          INCLUDE = /usr/dt/include: \
                    /usr/include: \
                    /usr/include/sys: \
                    /usr/openwin/include: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)/include

  LD_LIBRARY_PATH = /usr/lib: \
                    /usr/dt/lib: \
                    /usr/openwin/lib: \
                    $(GNUDIR)/lib: \
                    $(GNUDIR)/lib/gcc-lib/$(ARCHDIR)/$(PRODDIR)

             INCS  = -I../include -I. -I/usr/include/pgsql

             LIBS  = -lnsl -lpthread -lcurses -lmenu  -L/usr/sfw/lib

             FLAGS = -g 

             DEFS  = -D_REENTRANT -DSOLARIS

engtest      : debug debug/logs debug/engtest.o \
	     debug/cengine.o debug/cstring.o debug/util.o; \
	     $(CC) \
	     debug/engtest.o  debug/cengine.o debug/cstring.o  debug/util.o\
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/engtest 

newportmon   : debug debug/logs debug/parse.o \
	     debug/newportmon.o debug/cstring.o debug/cmessage.o; \
	     $(CC) \
	     debug/newportmon.o  debug/cstring.o debug/cmessage.o debug/parse.o\
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/newportmon 

stringtest   : debug debug/logs \
	     debug/stringtest.o debug/cstring.o; \
	     $(CC) \
	     debug/stringtest.o  debug/cstring.o \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/stringtest 

timetest     : debug debug/logs \
	     debug/timetest.o debug/ctimer.o; \
	     $(CC) \
	     debug/timetest.o debug/ctimer.o \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/timetest

longtest     : debug debug/logs \
	     debug/longtest.o ; \
	     $(CC) \
	     debug/longtest.o  \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/longtest

pfunctest    : debug debug/logs \
	     debug/pfunctest.o ; \
	     $(CC) \
	     debug/pfunctest.o  \
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/pfunctest

cworldtest   : debug debug/logs debug/cstring.o  debug/clist.o debug/cregion.o debug/cinode.o\
	     debug/main.o debug/cworld.o debug/cmodel.o debug/cpart.o debug/util.o; \
	     $(CC) debug/cworld.o debug/cmodel.o debug/clist.o debug/cregion.o debug/cinode.o\
	     debug/main.o debug/cpart.o debug/cstring.o debug/util.o\
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/cworldtest

cxtest       : debug ../shared/debug debug/logs\
	     debug/cxtest.o ../shared/debug/cxitem.o ../shared/debug/cstring.o ../shared/debug/util.o\
	     ../shared/debug/cengine.o ../shared/debug/mygetline.o;\
	     $(CC) \
	     debug/cxtest.o ../shared/debug/cxitem.o ../shared/debug/cstring.o ../shared/debug/util.o\
	     ../shared/debug/cengine.o ../shared/debug/mygetline.o\
	     $(LIBS) $(INCS) $(FLAGS) $(DEFS) -o debug/cxtest

debug/cxtest.o		: cxtest.cpp ../include/wiii_util.h;
			$(CC) -c cxtest.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cxtest.o

../shared/debug/cxitem.o	: ../shared/cxitem.cpp ../include/cxitem.hpp;
			$(CC) -c ../shared/cxitem.cpp $(INCS) $(FLAGS) $(DEFS) -o ../shared/debug/cxitem.o

../shared/debug/mygetline.o	: ../shared/mygetline.cpp ../include/mygetline.h;
			$(CC) -c ../shared/mygetline.cpp $(INCS) $(FLAGS) $(SOLDEFS) -o ../shared/debug/mygetline.o

debug/engtest.o		: engtest.cpp ../include/cengine.hpp ;
			$(CC) -c engtest.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/engtest.o

../shared/debug/cengine.o	: ../shared/cengine.cpp ../include/cengine.hpp ;
			$(CC) -c ../shared/cengine.cpp $(INCS) $(FLAGS) $(DEFS) -o ../shared/debug/cengine.o

debug/cinode.o		: ../shared/cinode.cpp cworld.h ../include/cinode.hpp  \
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c ../shared/cinode.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cinode.o

debug/cregion.o		: ../shared/cregion.cpp cworld.h ../include/cregion.hpp  \
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c ../shared/cregion.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cregion.o

debug/clist.o		: ../shared/clist.cpp cworld.h ../include/clist.hpp  \
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c ../shared/clist.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/clist.o

debug/main.o		: main.cpp cworld.h ../include/cworld.hpp  \
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c main.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/main.o

debug/cworld.o		: ../shared/cworld.cpp ../include/cworld.hpp cworld.h\
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c ../shared/cworld.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cworld.o

debug/cmodel.o		: ../shared/cmodel.cpp ../include/cmodel.hpp cworld.h ../include/cpart.hpp\
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c ../shared/cmodel.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cmodel.o

debug/cpart.o		: ../shared/cpart.cpp ../include/cpart.hpp cworld.h \
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c ../shared/cpart.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cpart.o

debug/newportmon.o	: newportmon.cpp ../include/cstring.hpp ../include/cmessage.hpp\
			../include/worldii.h ../include/wii_structures.h;
			$(CC) -c newportmon.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/newportmon.o

debug/parse.o		: parse.cpp ../include/cstring.hpp ../include/cmessage.hpp;
			$(CC) -c parse.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/parse.o

debug/cmessage.o	: ../shared/cmessage.cpp ../include/cmessage.hpp;
			$(CC) -c ../shared/cmessage.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/cmessage.o

debug/stringtest.o	: stringtest.cpp ../include/cstring.hpp;
			$(CC) -c stringtest.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/stringtest.o

debug/longtest.o	: longtest.cpp ;
			$(CC) -c longtest.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/longtest.o

debug/pfunctest.o	: pfunctest.cpp ;
			$(CC) -c pfunctest.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/pfunctest.o

debug/timetest.o	: timetest.cpp ../server-v3/ctimer.hpp;
			$(CC) -c timetest.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/timetest.o

../shared/debug/cstring.o	: ../shared/cstring.cpp ../include/cstring.hpp;
			$(CC) -c ../shared/cstring.cpp $(INCS) $(FLAGS) $(DEFS) -o ../shared/debug/cstring.o

debug/ctimer.o		: ../server-v3/ctimer.cpp ../server-v3/ctimer.hpp;
			$(CC) -c ../server-v3/ctimer.cpp $(INCS) $(FLAGS) $(DEFS) -o debug/ctimer.o

../shared/debug/util.o		: ../shared/util.cpp ../include/wiii_util.h;
			$(CC) -c ../shared/util.cpp $(INCS) $(FLAGS) $(DEFS) -o ../shared/debug/util.o

debug/logs	  :
	test ! -d debug/logs && mkdir debug/logs

debug      :
	test ! -d debug && mkdir debug

../shared/debug      :
	test ! -d ../shared/debug && mkdir ../shared/debug

.PHONY : clean

clean :
	rm -r debug 
