////////////////////////////////////////////////////////////////////////////////////////////////////
// locktest.cpp 
// This is the main module for the locktest application.
//
// World III
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 31 Jan 2006
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <pthread.h>
#include <strings.h>



////////////////////////////////////////////////////////////////////////////////////////////////////
// Globals
////////////////////////////////////////////////////////////////////////////////////////////////////
bool			debug;
unsigned long		add;
unsigned long		dec;
unsigned long		count;
pthread_mutex_t 	lock;
pthread_mutexattr_t     m_attr;

pthread_attr_t          attr; 

////////////////////////////////////////////////////////////////////////////////////////////////////
// External Functions
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Init
////////////////////////////////////////////////////////////////////////////////////////////////////
void Init(int argc, char** argv)
{
int i;


	// find out if we are debugging
	if ((argc==2) && (strcmp(argv[1],"debug")==0))
	{
		printf("DEBUGMODE ON\n");
		debug=true;
		}
	pthread_mutexattr_init(&m_attr);
	pthread_mutexattr_settype(&m_attr,PTHREAD_MUTEX_ERRORCHECK_NP);
//	pthread_mutex_init(&lock, &m_attr);
	pthread_mutex_init(&lock, NULL);
	

	pthread_attr_init(&attr);
//	pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	pthread_attr_setscope(&attr, PTHREAD_SCOPE_PROCESS);

	} //////////////////////////////////////////////////////////////////////////////////end Init


////////////////////////////////////////////////////////////////////////////////////////////////////
// Add
// This simply incs the counter
////////////////////////////////////////////////////////////////////////////////////////////////////
void *Add(void *p)
{
int j=0;
	while (1)
	{
		pthread_mutex_lock(&lock);
		if (add <10000000)
		{
			add++;
			count++;
			pthread_mutex_unlock(&lock);
			}
		else
		{
			pthread_mutex_unlock(&lock);
			return (0);
			}
		j++;
		if (j>1000)
		{
			j=0;
			pthread_yield();
			}
		}
	} ///////////////////////////////////////////////////////////////////////////////////end Add

////////////////////////////////////////////////////////////////////////////////////////////////////
// Dec
// This simply incs the counter
////////////////////////////////////////////////////////////////////////////////////////////////////
void *Dec(void *p)
{
int j=0;
	while (1)
	{
		pthread_mutex_lock(&lock);
		if (dec<10000000)
		{
			dec++;
			count--;
			pthread_mutex_unlock(&lock);
			}
		else
		{
			pthread_mutex_unlock(&lock);
			return (0);
			}
		j++;
		if (j>1000)
		{
			j=0;
			pthread_yield();
			}
		}
	} ///////////////////////////////////////////////////////////////////////////////////end Dec

////////////////////////////////////////////////////////////////////////////////////////////////////
// Prints
// This simply incs the counter
////////////////////////////////////////////////////////////////////////////////////////////////////
void *Prints(void *p)
{
int j=0;
	while (1)
	{
		pthread_mutex_lock(&lock);
		if ((add>=10000000) && (dec>=10000000))
		{
			pthread_mutex_unlock(&lock);
			return (0);
			}
		printf("count=%d, add=%d, dec=%d  \n",count,add,dec);
		pthread_mutex_unlock(&lock);
		j++;
		if (j>100)
		{
			j=0;
			pthread_yield();
			}
		}
	} ////////////////////////////////////////////////////////////////////////////////end Prints

////////////////////////////////////////////////////////////////////////////////////////////////////
// Main
////////////////////////////////////////////////////////////////////////////////////////////////////
int main(int argc, char** argv)
{
char		c[4];
void            *param;
pthread_t	ttempa;
pthread_t	ttempd;
pthread_t	ttempp;

	// init the screen & then threading and such
	// erase the screen
	Init(argc, argv);		// Init debug model

	// Start three threads. Then let them race to see who does whaty first.
	pthread_create( &ttempa, NULL, Add, NULL);
	pthread_create( &ttempd, NULL, Dec, NULL);
	pthread_create( &ttempp, NULL, Prints, NULL);
//	pthread_create( &ttempa, &attr, Add, NULL);
//	pthread_create( &ttempd, &attr, Dec, NULL);
//	pthread_create( &ttempp, &attr, Prints, NULL);
	pthread_join(ttempa,NULL);
	pthread_join(ttempd,NULL);
	pthread_join(ttempp,NULL);
	
//	if (true) printf("TRUE\n");
//	if (!true) printf("NOT TRUE\n");

//	if (!false) printf("NOT FALSE\n");
//	if (false) printf("FALSE\n");

	printf("Returning from main.\n");
} //////////////////////////////////////////////////////////////////////////////////////////end main

