//////////////////////////////////////////////////////////////////////////////////////////////
// stringtest.cpp 
// 
// This will be a test bed for the CString class. 
//
// World II
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 23 Jan 2007
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
//////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////
// Defines
//////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////
// Includes
//////////////////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/timeb.h>			// needed by logging

#include "cstring.hpp"
#include "wiii_util.h"

//////////////////////////////////////////////////////////////////////////////////////////////
// Globals
//////////////////////////////////////////////////////////////////////////////////////////////
pthread_mutex_t         logmutex;	// needed by logging
pthread_mutex_t         screenmutex;	// needed by logging
long                    logcount;	// needed by logging
int                     loglevel;	// needed by logging
struct timeb            starttime;	// needed by logging
CString			Log;

////////////////////////////////////////////////////////////////////////////////////////////////////
// Init
////////////////////////////////////////////////////////////////////////////////////////////////////
void Init()
{

	// assign the log function to the static class var inside CString
	Log.SetLogFunc(ThreadLog);
	} //////////////////////////////////////////////////////////////////////////////////end Init

////////////////////////////////////////////////////////////////////////////////////////////////////
// Main
////////////////////////////////////////////////////////////////////////////////////////////////////
main()
{
CString		A("AAAAA");
		printf("Count=%d\n",A.GetCount());
CString		B("BBBBB");
CString		C;
CString		a;
CString		b("Hello Worldiii.\n");
CString		c;
CString		apptest("Append test '");
CString		d;
CString		e;
CString		g;
CString		n("1");
CString		r("\n");
CString		*temp;
CString		x("Hello Worldiii.");
CString		y("Hello Worldiii.");
CString		x1("Hello Worldiii.");
CString		y1("Hello Yorldiii.");
CString		*ns, *ns1;
		printf("Count=%d\n",A.GetCount());
		printf("Count=%d\n",e.GetCount());
		printf("Count=%d\n",x.GetCount());
char somestring[]="SOME RANDOM STRING";
char buf[256];
char buf1[256];
char *s;
FILE *f;
int	i;
bool	done;
float	fl;
int	il;
int	nn;
int	itest=23456;
unsigned long int ultest=4000000000;

	printf("Call Init \n");
	Init();		// 

	// test appending a converted int
	printf("=========================Append integer test \n");
	apptest.Display();
	apptest.Append(itest);
	apptest.Append('\'');
	apptest.Append('\n');
	apptest.Display();
	apptest="Append test '";
	apptest.Append(ultest);
	apptest.Append('\'');
	apptest.Append('\n');
	apptest.Display();

	// test Display (a debug function)
	printf("=========================Display test \n");
	b.Display();
	c.SetString("This is some more data. \n");
	c.Display();
	g.SetString("[v] 	   0	 	 	   0.0    	0.3 	    0.0			0.0 	   0.0	    1.0       	0.0   1.0");	// this contains tabs

	// Assign 
	printf("=========================Assign test \n");
	d=c;
	d.Display();

	// Assign 
	printf("=========================Another assign test \n");
	d=b;
	d.Display(); 

	// Set Char 
	printf("=========================SetChar test \n");
	d.SetChar(5,'X');
	d.Display();

	// Append 
	printf("=========================Append test \n");
	d="This was the original stuff";
	d.Append("->THIS IS APPENDED.<-\n ");
	r.Display();	// r is a new line
	d.Display();

	// Setstring and getstring 
	printf("=========================Set/Get String test \n");
	e.SetString("SETSTRING.          ");
	e.GetString(&s);
	printf("THIS IS a test of SetString/GetStrin '%s' length is %d\n",s,e.GetLength());
	e.Chop(" ");
	delete [] s;
	e.GetString(&s);
	printf("THIS IS a test after one chop '%s' length is %d\n",s,e.GetLength());
	e.Chop(" ");
	delete [] s;
	e.GetString(&s);
	printf("THIS IS a test after two chops '%s' length is %d\n",s,e.GetLength());
	delete [] s;

	// token  
	printf("=========================TOKEN TEST single delim\n");
	printf("LINE = '");c.Display(); printf("'\n");
	c.TokenInit(" ");
	while ((temp=c.GetToken())!=NULL)
	{
		temp->GetString(&s);
		printf("Next token   '%s' length is  %d \n",s,temp->GetLength());
		delete [] s;
		}
	
	// token  
	printf("=========================TOKEN TEST delim string\n");
	g.TokenInit(" 	"); // this contains a tab
	printf("LINE = '");g.Display(); printf("'\n");
	while ((temp=g.GetToken())!=NULL)
	{
		temp->GetString(&s);
		printf("Next token   '%s' length is  %d \n",s,temp->GetLength());
		delete [] s;
		}

	// test compare string
	printf ("=========================COMPARE TESTS\n");
	printf ("should be true =>");
	if (x==y) printf ("x==y => TRUE \n"); else printf ("x==y => FALSE \n");

	printf ("should be false =>");
	if (x=="Hello Worldii.") printf ("x==\"Hello Worldii.\" => TRUE \n"); else printf ("x==\"Hello Worldii.\" => FALSE \n");

	printf ("should be false =>");
	y.Append("z");
	if (x==y) printf ("y.Append(\"z\"); x==y => TRUE \n"); else printf ("y.Append(\"z\"); x==y => FALSE \n");
	x.Append("zz");
	if (x==y) printf ("x.Append(\"zz\"); x==y => TRUE \n"); else printf ("x.Append(\"zz\");  x==y => FALSE \n");
	
	if (x1==y1) printf ("x1==y1 => TRUE \n"); else printf ("x1==y1 => FALSE \n");
	printf (" x1==\"Hello Worldii.\" => %d \n",x1.StrNCmp("Hello Worldii.",15));
	printf (" x1==\"Hello Worldih.\" => %d \n",x1.StrNCmp("Hello Worldih.",15));
	printf (" x1==\"Hello Worldij.\" => %d \n",x1.StrNCmp("Hello Worldij.",15));

	{
	CString s1="abcd";
	CString s2="abcd";
	CString s3="abce";
	CString s4="abcc";
		if (s1<s3)    printf("s1<s3\n");else printf("s1>=s3\n");
		if (s1 == s2) printf("s1==s2\n");else printf("s1!=s2\n");
		if (s1 == s3) printf("s1==s3\n");else printf("s1!=s3\n");
		if (s3>s1)    printf("s3>s1\n");else printf("s3<=s1\n");
		}

	// test compare to NULL
	printf ("=========================NULL TESTS\n");
	ns=NULL;
	ns1=NULL;
	if (*ns=="test") printf("TESTED OK FOR NULL COMPARE  (ns==\"test\")\n");
	else printf("TESTED OK FOR NULL COMPARE  (ns==\"test\") (it was false)\n");
	if (ns==NULL) printf("TESTED OK FOR NULL COMPARE  (ns==NULL)\n");
	if (ns==ns1) printf("TESTED OK FOR NULL COMPARE  (ns==ns1)\n");

	// integer get test
	printf ("=========================get int tests\n");
	n.TokenInit(" ");
	n.GetInt(&nn);
	printf (" n= %d \n",nn);

	//  make sure data file is in the directory
	f=fopen("/home/eric/src/wiii/misc/debug/data.txt","r");

	// test fgets
	printf ("=========================fgets tests\n");
	fgets(buf,40,f);
	printf("line='%s' count=%d \n",buf,strlen(buf));

	// test fgets
	printf ("=========================fgets tests\n");
	fgets(buf,40,f);
	printf("line='%s' count=%d \n",buf,strlen(buf));

	fclose(f);

	// try with CString
	printf ("=========================CString->FGetS tests\n");
	f=fopen("data.txt","r");
	a.FGetS(f);
	printf (" FGetS=== \n");
	a.Display();
	fclose(f);

	f=fopen("data.txt","r");
	// try with CString
	i=0;
	done=false;
	printf ("==========================File read GetLine=== \n");
	do 
	{
		if (a.GetLine(f)) 
		{
			a.Chomp();
			if (a.StrNCmp("//" ,2)==0) printf("Found comment line ====> "); 
			if (a.StrNCmp("[v]",3)==0) printf("Found vertex line  ====> "); 
			a.Display();
			printf("\n");
			}
		else done=true;
		i++;
		} while (!done);
	fclose(f);
	a.SetString("12.1 12.2 12.3 12.4");
	a.TokenInit(" ");
	a.Display();printf("\n");
	if (a.GetFloat(&fl))  printf("one=%f \n",fl);
	if (a.GetFloat(&fl))  printf("two=%f \n",fl);
	if (a.GetInt(&il))    printf("three=%d \n",il);
	if (a.GetFloat(&fl))  printf("four=%f \n",fl);


//	printf("two=%f three=%f four=%f\n",a.GetFloat(),a.GetFloat(),a.GetFloat(),a.GetFloat());
	// overloaded tests
	printf ("==========================operator+ overloading tests \n");
	C=A+B+"\n";
	C.Display();

	C=C+"HEY FRED!!\n";
	C.Display();

	C=A+"\n"+B+"\n";
	C.Display();

	C="\n"+B+"\n";	
	C=somestring+B+"\n";	
	C.Display();

	C=A+"\n"+"\n";
	C.Display();

	C=A+"\n"+"\n"+B;
	C.Display();

	C=A+somestring+B+"\n";
	C.Display();
	printf("====================================================================\n");
	C="direct set string";
	sscanf(buf,"%x",32);
	C=C+" hex='"+buf+"'\n";
	C.Display();

	ns=new CString;
	printf("Count=%d\n",ns->GetCount());

	*ns="this is my log string";
	for (i=0; i<500000;i++)
	{
		snprintf(buf,256,"PREPEND:%s",ns->GetStringPtr());
		snprintf(buf1,256,"%s:APPEND",buf);
		ThreadLog(buf1);
//		ns->Log("PREPEND:",":APPEND\n");
		}

} //////////////////////////////////////////////////////////////////////////////////////////end main

