/////////////////////////////////////////////////////////////////////////////////////////////
// ConServer
// conserv.cpp -- the server main module
//
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jun 2006
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Includes
/////////////////////////////////////////////////////////////////////////////////////////////
#include <sys/socket.h>
#include <sys/errno.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#include "cusock.hpp"
//#include "wiii_types.h"
#include "worldiii.h"
#include "wiii_util.h"
#include "console.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Externals
////////////////////////////////////////////////////////////////////////////////////////////////////
extern	char		logfilename[];
extern	bool		listenstate;
extern	int		loglevel;
extern	void		ThreadLog(char *s);
extern	void		ConPrint(char *);
extern	void		ConPrint(CString *);

////////////////////////////////////////////////////////////////////////////////////////////////////
// Local Globals
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Terminate
////////////////////////////////////////////////////////////////////////////////////////////////////
void Terminate()
{
//CServer *s;
//CSock	*p;

	ConPrint("Message to console : In Terminate.");
//     // Terminate each servers threads by calling the CServer term functions
//     serverlist.MoveFirst();
//     while (!serverlist.EndList())
//     {
//          s=(CServer *)serverlist.GetCurrent();
//
//          // tell each thread in each server to end
//          p=s->GetSockPtr();
//          p->Close();
//          s->PortmonDone();
//          s->QLoaderDone();
//          s->ServerDone();
//          serverlist.MoveNext();
//          }

     // Then Flush ccache

     } /////////////////////////////////////////////////////////////////end Terminate

////////////////////////////////////////////////////////////////////////////////////////////////////
// DebugMode
////////////////////////////////////////////////////////////////////////////////////////////////////
void DebugMode()
{
//	debug=!debug;
	loglevel++;
	if (loglevel>9) loglevel=0;
	if (loglevel>0) ConPrint("Debug Mode is ON.");
	else ConPrint("Debug Mode is OFF.");
} /////////////////////////////////////////////////////////////////////////////////////end DebugMode

////////////////////////////////////////////////////////////////////////////////////////////////////
// CloseClient
// This is a test only function for now. Because the server infrastructure is not in place yet, 
// we will just jury rig a test close. then use the test charclient code to report when the 
// connection has been closed.
////////////////////////////////////////////////////////////////////////////////////////////////////
void CloseClient()
{
	} ///////////////////////////////////////////////////////////////////////////end CloseClient

////////////////////////////////////////////////////////////////////////////////////////////////////
// ListClients
////////////////////////////////////////////////////////////////////////////////////////////////////
void ListClients()
{
//CItem *p,*q;
//CChar *c;
//CString *s;
//char buf[80];
//
//     // Call member function to list all clients 
//     // I dont think that i derived world_cache from CIterator
//     // need to add functions to internally create a "cursor"
//     // and use the cursor to do the iteration.
//     p=world_cache->TestSetFirst(PLAYERLIST);
//     while (!(world_cache->TestEndList(PLAYERLIST)))
//     {
//          p=world_cache->GetObjPtr(PLAYERLIST);
//          c=(CChar *)p;
//          snprintf(buf,80,"Char = %s.  playerid = %d.\n ",(c->GetFName()),((CObject *)c)->GetObjectId());
//          ConPrint(buf);
//          world_cache->TestIterate(PLAYERLIST);
//          }
	ConPrint("Message to console : List Clients. ");
	} ///////////////////////////////////////////////////////////////end ListClients

////////////////////////////////////////////////////////////////////////////////////////////////////
// ConServer
// a return value of true means close the console connection
////////////////////////////////////////////////////////////////////////////////////////////////////
bool ConServer(char *data, int count)
{
int 	runningtime;
//char 	buf[80];
int 	msg;
bool 	retval;

	// we know this by being here.
	if (loglevel>=1) ThreadLog("ConServer: Entering ConServer.\n");  

	// set up some vars 
	runningtime=0;

	// get the sizeof(int) number of bytes and treat as an integer
//	msg=*(int*)(data);
	msg=*(unsigned char*)(data);
	retval=false;

	switch (msg)
	{
	case CON_COMM_LISTEN:
		ThreadLog("Message to console : Try to listen.\n");
		ConPrint( "Message to console : Try to listen.\n");
		listenstate=THREAD_ST_LISTEN;
		break;

	case CON_COMM_PAUSE:
		ConPrint("Message to console : Try to pause.\n");
		listenstate=THREAD_ST_PAUSE;
		break;

	case CON_COMM_SHOW_SERVERS:
		ConPrint("Message to console : Show servers.\n");
//		Show();
		break;

	case CON_COMM_CLOSE:
		ConPrint("Message to console : Attempting close client.\n");
		CloseClient();
		break;

	case CON_COMM_LIST_CLIENTS:
		ConPrint("Message to console : List clients.\n");
		ListClients();
		break;

	case CON_COMM_DEBUG:
		ConPrint("Message to console : Set debug mode.\n");
		DebugMode();
		break;

	case CON_COMM_TERM:
		Terminate();
		retval=true;
		break;

	default:
		break;
		} // end switch msg

	if (loglevel>=1) ThreadLog("ConServer: Exiting ConServer.\n");  
	return (retval);
	} /////////////////////////////////////////////////////////////////////////////end ConServer

