////////////////////////////////////////////////////////////////////////////////////////////////////
// cinode.cpp (client and modeler)
// This class will implement the model object 
//  
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jan 2006 
//  
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h> 
#include <string.h>

#include "cworld.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////
// Externals
////////////////////////////////////////////////////////////////////////////////////////////////////
extern bool	debug;
extern char	logfilename[];

////////////////////////////////////////////////////////////////////////////////////////////////////
// CInode Constructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CInode::CInode()
{
	model=0;
	next=0;
	prev=0;
	xpos=0.0f;
	ypos=0.0f;
	zpos=0.0f;
	roll=0.0f;
	pitch=0.0f;
	yaw=0.0f;
	} ////////////////////////////////////////////////////////////////////////////////end CInode

////////////////////////////////////////////////////////////////////////////////////////////////////
// CInode Destructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CInode::~CInode()
{
	// BUILD DESTRUCTOR !!!!!!!!
	// 977K memory leak !!!!!!!!
	} ////////////////////////////////////////////////////////////////////////////end Destructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CModInode Constructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CModInode::CModInode()
{

	// This is for debugging and for inititalization 
	model=0;
//	portal=0;
	next=0;
	prev=0;
	xpos=0.0f;
	ypos=0.0f;
	zpos=0.0f;
	roll=0.0f;
	pitch=0.0f;
	yaw=0.0f;
	} ///////////////////////////////////////////////////////////////////////////end Constructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CModInode Destructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CModInode::~CModInode()
{
	// BUILD DESTRUCTOR !!!!!!!!
	// 977K memory leak !!!!!!!!
	} ////////////////////////////////////////////////////////////////////////////end Destructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CModInode SetTrans
////////////////////////////////////////////////////////////////////////////////////////////////////
void CModInode::SetTrans(GLfloat x, GLfloat y, GLfloat z)
{
	xpos=x;
	ypos=y;
	zpos=z;
	} //////////////////////////////////////////////////////////////////////////////end SetTrans

////////////////////////////////////////////////////////////////////////////////////////////////////
// CModInode SetRot
////////////////////////////////////////////////////////////////////////////////////////////////////
void CModInode::SetRot(GLfloat r, GLfloat p, GLfloat y)
{
	roll=r;
	pitch=p;
	yaw=y;
	} ////////////////////////////////////////////////////////////////////////////////end SetRot

