///////////////////////////////////////////////////////////////////////////////////////////////////
// cpart.cpp (client and modeler)
// This class will implement the part object 
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jan 2006 
//  
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
///////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h> 
#include <string.h>

#include "cworld.hpp"

///////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// Externals
///////////////////////////////////////////////////////////////////////////////////////////////////

extern char logfilename[];
extern void PrintCWorldError(int);

///////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Constructor
///////////////////////////////////////////////////////////////////////////////////////////////////
CPart::CPart()
{
int i;

	// This is for debugging and for inititalization 
	framecount=0;
	for (i=0;i<MAXFRAMECOUNT;i++)
	{
		list[i]=0;
		}
	nextpart=0;
	} ///////////////////////////////////////////////////////////////////////////end Constructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Destructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CPart::~CPart()
{
	// BUILD DESTRUCTOR !!!!!!!!
	// 977K memory leak !!!!!!!!
	} ////////////////////////////////////////////////////////////////////////////end Destructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Destructor
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CPart::Init()
{
	return true;
	} //////////////////////////////////////////////////////////////////////////////////end Init

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart InsertList
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CPart::InsertList(CList *l, int i) 
{

	// Insert  list
	if ((i>=0) && (i<MAXFRAMECOUNT) && (l))
	{
		list[i]=l;
		framecount++;
		return (true);
		}
	else return (false);
	} ////////////////////////////////////////////////////////////////////////////end InsertList

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart InsertList
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CPart::InsertList(CList *l)                                                
{

        // Insert  list
        if (l)
        {
	int i;
	bool found;
		found=false;
		i=0;
		while ((i<MAXFRAMECOUNT)&&(!found))
		{
			if (!list[i]) found=true;
			else i++;
			}
                list[i]=l;
                framecount++;
                return (true);
		}
	else return (false);
	} ////////////////////////////////////////////////////////////////////////////end InsertList

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Load
////////////////////////////////////////////////////////////////////////////////////////////////////
int CPart::Load(FILE *f,int level)
{
char		token[80];	// this is where tokens are returned to
int		i,result;
CList		*newlist;
CString		*tok,line;
char		delimss[3]={' ','\t','\0'};	// <<===String contains a tab and a space

	// get frame count
CPartLoad1:
	// Get a Line
	if (line.GetLine(f))
	{
		// check if first chars in string are comment chars
		if (line.StrNCmp("//",2)==0)
		{
			printf("FOUND COMMENT =>"); line.Display();// printf("\n");
			goto CPartLoad1;
			}

		// If we read a line that is too short go back and get another line
		if (line.GetLength()<=2) goto CPartLoad1;
		line.Chomp();

		// check tokens to ensure format correct (FIXME)
		line.TokenInit(delimss);    
		tok=line.GetToken();
		if (!line.GetInt(&framecount)) return (CW_ERR_CONVERSION);        //
                }

	// Now load the frames 
	for (i=0;i<framecount;i++)
	{
		newlist= new CList;
		if (newlist) 
		{
			result=newlist->Load(f,level);
			if (result!=CW_OK)
			{
				printf("CPart:: Load: Error loading CList.\n");
				PrintCWorldError(result);
				delete newlist;
				return CW_ERR_LISTLOAD;
				}
			}
		else return CW_ERR_MEMALLOCATE;	
		list[i]=newlist;
		}

	return CW_OK;
	} //////////////////////////////////////////////////////////////////////////////////end Load

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Render
////////////////////////////////////////////////////////////////////////////////////////////////////
int CPart::Render()
{
int	i;

	for (i=0;i<framecount;i++)
	{
		// now pass call to each CList
		if ((list[i]->Render())==CW_ERR_RENDER) return CW_ERR_RENDER;
		}
	return CW_OK;
	} ////////////////////////////////////////////////////////////////////////////////end Render

////////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Destroy
////////////////////////////////////////////////////////////////////////////////////////////////////
int CPart::Destroy()
{
int	i;

	for (i=0;i<framecount;i++)
	{
		// now pass call to each CList
		if (!(list[i]->Destroy())) return 1;
		}
	return 0;
	} ///////////////////////////////////////////////////////////////////////////////end Destroy

///////////////////////////////////////////////////////////////////////////////////////////////////
// CPart Save
///////////////////////////////////////////////////////////////////////////////////////////////////
bool CPart::Save(FILE *f)
{
int		i;

	// get frame count
	fprintf(f,"%s %d\n", "[framecount]",framecount);

	for (i=0;i<framecount;i++)
	{ 
		if (!(list[i]->Save(f))) return false;
		}


	return true;
	} //////////////////////////////////////////////////////////////////////////////////end Save


