////////////////////////////////////////////////////////////////////////////////////////////////////
// cstring.cpp (merged)
// Should have done this a LONG time a go. 
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 15 Jan 2007
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldiii@viagloria.com
//              web             www.viagloria.com
////////////////////////////////////////////////////////////////////////////////////////////////////
// Thanks to Fred Swarz for deep copy example !
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#ifdef SOLARIS
#include <strings.h>
#include "mygetline.h"
#endif

#include "cstring.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Externals
////////////////////////////////////////////////////////////////////////////////////////////////////
extern char logfilename[];
extern char qloaderlogname[];

////////////////////////////////////////////////////////////////////////////////////////////////////
// Globals
////////////////////////////////////////////////////////////////////////////////////////////////////
LOGFUNCPTRTYPE	CString::LogFunc=0;
unsigned long   CString::count;
unsigned long   CString::logfunc;


////////////////////////////////////////////////////////////////////////////////////////////////////
// SetLogFunc
////////////////////////////////////////////////////////////////////////////////////////////////////
//void CString::SetLogFunc(void (*pfunc)(char*))
void CString::SetLogFunc(LOGFUNCPTRTYPE pfunc)
{
//	printf("LogFunc=%lu\n",(unsigned long)LogFunc);
//	printf("pfunc=%lu\n",(unsigned long)pfunc);
	LogFunc=pfunc;
//	logfunc=(unsigned long)pfunc;
//	printf("LogFunc=%lu\n",(unsigned long)LogFunc);
	} ////////////////////////////////////////////////////////////////////////////end SetLogFunc

////////////////////////////////////////////////////////////////////////////////////////////////////
// Log (Overloaded)
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Log()
{

	if (LogFunc) (*LogFunc)(buf);
	} ///////////////////////////////////////////////////////////////////////////////////end Log

////////////////////////////////////////////////////////////////////////////////////////////////////
// Log (Overloaded)
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Log(char *beforestring)
{
char	*s;
int	b;

	if (!LogFunc) return;
	b=strlen(beforestring);
	s = new char[length+b+1];
	strncpy(s,beforestring,b);
	strncpy(s+b,buf,length);
	s[b+length]='\0';
	(*LogFunc)(s);
	delete [] s ;
	} ///////////////////////////////////////////////////////////////////////////////////end Log

////////////////////////////////////////////////////////////////////////////////////////////////////
// Log (Overloaded)
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Log(char *beforestring, char *afterstring)
{
char	*s;
int	a;
int	b;

	if (!LogFunc) return;
	a=strlen(afterstring);
	b=strlen(beforestring);
	s = new char[b+length+a+1];
	strncpy(s,beforestring,b);
	strncpy(s+b,buf,length);
	strncpy(s+b+length,afterstring,a);
	s[b+length+a]='\0';
	(*LogFunc)(s);
	delete [] s ;
	} ///////////////////////////////////////////////////////////////////////////////////end Log

////////////////////////////////////////////////////////////////////////////////////////////////////
// Print (Overloaded)
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Print()
{

	printf("%s",buf);
	} /////////////////////////////////////////////////////////////////////////////////end Print

////////////////////////////////////////////////////////////////////////////////////////////////////
// Print (Overloaded)
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Print(char *beforestring)
{
char	*s;
int	b;

	b=strlen(beforestring);
	s = new char[length+b+1];
	strncpy(s,beforestring,b);
	strncpy(s+b,buf,length);
	s[b+length]='\0';
	printf("%s",s);
	delete [] s ;
	} /////////////////////////////////////////////////////////////////////////////////end Print

////////////////////////////////////////////////////////////////////////////////////////////////////
// Print (Overloaded)
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Print(char *beforestring, char *afterstring)
{
char	*s;
int	a;
int	b;

	a=strlen(afterstring);
	b=strlen(beforestring);
	s = new char[b+length+a+1];
	strncpy(s,beforestring,b);
	strncpy(s+b,buf,length);
	strncpy(s+b+length,afterstring,a);
	s[b+length+a]='\0';
	printf("%s",s);
	delete [] s ;
	} /////////////////////////////////////////////////////////////////////////////////end Print

////////////////////////////////////////////////////////////////////////////////////////////////////
// Min
////////////////////////////////////////////////////////////////////////////////////////////////////
int Min(int a, int b)
{

	// return smallest
	if (a<=b) 
	{
		return (a);
		}
	else return (b);
	} ///////////////////////////////////////////////////////////////////////////////////end Min

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Constructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CString::CString()
{
int	i;

	// set state
	length=0;
	buf=0;
	nextchar=0;
	tokinitready=false;
	for (i=0;i<MAX_DELIM_LEN;i++) dstring[i]='\0';
	delim_len=0;
//	LogFunc=0;
	logfunc=0;
	count++;
	} ///////////////////////////////////////////////////////////////////////////end Constructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Constructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CString::CString(const char *s)
{
int	i;

	//// need to check for pre-existing string as we can do this:
	//// CString somestring;
	//// somestring.SetString("use the cstring");
	////
	//// somestring="reuse the CString someother way";
	//// 
	
	// check for pre-existing buf
//	if (buf) 
//	{
//		delete [] buf;
//		length=0;
//		}

	length=strlen(s);		// note that the length stored here, does NOT include the 
	buf=new char[length+1];	// terminating '\0'
//	strcpy(buf,s);	FIXME strncpy ?????
	strcpy(buf,s);
	nextchar=0;
	tokinitready=false;
//	printf("USED THIS CONSTRUCTOR\n");
	for (i=0;i<MAX_DELIM_LEN;i++) dstring[i]='\0';
	delim_len=0;
//	LogFunc=0;
	logfunc=0;
	count++;
	} ///////////////////////////////////////////////////////////////////////////end Constructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Constructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CString::CString(char c, int n)
{
int	i;

	length=n;
	buf=new char[length+1];
	memset(buf,c,length);
	buf[length]='\0';
	tokinitready=false;
	for (i=0;i<MAX_DELIM_LEN;i++) dstring[i]='\0';
	delim_len=0;
//	LogFunc=0;
	count++;
	} ///////////////////////////////////////////////////////////////////////////end Constructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Constructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CString::CString(const CString &other)
{
int	i;
//	printf("YAHOO !!!! USED THIS ONE TOO\n");
	if ((length = other.length))
	{
		buf = new char[length+1];
		strncpy(buf,other.buf,length+1);
		delim_len=0;
		for (i=0;i<MAX_DELIM_LEN;i++) dstring[i]='\0';
		nextchar=0;
		tokinitready=false;
		}
	else
	{
		buf=0;
		length=0;
		delim_len=0;
		for (i=0;i<MAX_DELIM_LEN;i++) dstring[i]='\0';
		nextchar=0;
		tokinitready=false;
		}
	} //////////////////////////////////////////////////////////////////////end Copy Constructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Destructor
////////////////////////////////////////////////////////////////////////////////////////////////////
CString::~CString()
{
	if (buf) delete [] buf ;
	count--;
	if (count<0) count=0;
	} ////////////////////////////////////////////////////////////////////////////end Destructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// GetCount
////////////////////////////////////////////////////////////////////////////////////////////////////
unsigned long CString::GetCount()
{
	return (count);
	} //////////////////////////////////////////////////////////////////////////////end GetCount

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString SetString
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::SetString(const char *s)
{

	// 
	if (buf==0) assert(length==0);
	if (length==0) assert(buf==0);
	if ((buf!=0) && (length!=0)) delete [] buf;
	length=strlen(s);
	buf=new char[length+1];
//	strcpy(buf,s);
	strncpy(buf,s,length+1);
	} /////////////////////////////////////////////////////////////////////////////end SetString

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString SetString, overload
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::SetString(const char *s,int l)
{

	// here we DONT copy the whole input string, we just copy the first l chars
	if ((buf!=0) && (length!=0)) delete [] buf;
	length=l;
	buf=new char[l+1];
	strncpy(buf,s,l);
	buf[l]='\0';
	} /////////////////////////////////////////////////////////////////////////////end SetString

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Reset
// Log function remains the same
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Reset()
{
int	i;

	// 
	if (buf!=0) delete [] buf;
	length=0;
	buf=0;
	tokinitready=false;
	for (i=0;i<MAX_DELIM_LEN;i++) dstring[i]='\0';
	delim_len=0;
	} /////////////////////////////////////////////////////////////////////////////////end Reset

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString SetChar
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::SetChar(int index, char newchar)
{
	if ((index>=0) && (index<=length))  buf[index]=newchar; 
	} ///////////////////////////////////////////////////////////////////////////////end SetChar

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetChar
// Get character at position index
////////////////////////////////////////////////////////////////////////////////////////////////////
char CString::GetChar(int index)
{
	if ((index>=0) && (index<=length)) return (buf[index]); 
	else return 0;
	} ///////////////////////////////////////////////////////////////////////////////end GetChar

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Append
// Overloaded
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::Append(const char addition)
{
char *temp;

	if (length==0 && buf==0)
	{
		// append to a null string
		length = 1;
		if (!(buf=new char[length+1])) return false;
		buf[0]=addition;
		buf[1]='\0';
		return true;
		}
	else
	{
		// append to existing string
		length += 1;
		if (!(temp=new char[length+1])) return false;
		strncpy(temp,buf,length-1);
		temp[length-1]=addition;	// remember length DOES NOT include terminating \0
		temp[length]='\0';
		delete [] buf;
		buf=temp;
		return true;
		}
	} ////////////////////////////////////////////////////////////////////////////////end Append

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString IntAppend
// Overloaded
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::IntAppend(const char* addition)
{
char *temp;

//	if (buf==0)		should it be this ?
	if (length==0 && buf==0)
	{
		// append to a null string
		length += strlen(addition);
		buf=new char[length+1];
		strcpy(buf,addition);
		}
	else
	{
		// append to existing string
		length += strlen(addition);
		temp=new char[length+1];
		strcpy(temp,buf);
		strcat(temp,addition);
		delete [] buf;
		buf=temp;
		}
	} /////////////////////////////////////////////////////////////////////////////end IntAppend

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Append
// Overloaded
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Append(const char* addition)
{
	IntAppend(addition);
//char *temp;
//
////	if (buf==0)		should it be this ?
//	if (length==0 && buf==0)
//	{
//		// append to a null string
//		length += strlen(addition);
//		buf=new char[length+1];
//		strcpy(buf,addition);
//		}
//	else
//	{
//		// append to existing string
//		length += strlen(addition);
//		temp=new char[length+1];
//		strcpy(temp,buf);
//		strcat(temp,addition);
//		delete [] buf;
//		buf=temp;
//		}
	} ////////////////////////////////////////////////////////////////////////////////end Append

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator=
////////////////////////////////////////////////////////////////////////////////////////////////////
CString &CString::operator=(const CString &other)
{
	if (&other==this) return (*this);
	length=other.length;
	delete [] buf;
	buf=new char[length+1];			// term null not included in length
	strncpy(buf, other.buf, length);
	buf[length]='\0';
	
	// this is put in to appease the compiler.
	// if it gives weird results CHECK THIS !
	//
	// TEST
	// From web example this allows for multiple assignment
	// x=y=z;
	//http://www.fredosaurus.com/notes-cpp/oop-overloading/overloadassign.html
	return(*this);
	} /////////////////////////////////////////////////////////////////////////////end operator=

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator<
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator<(const CString &other)
{
	// trivial cases
	// the reasoning here is a value that exists 
	// cant be less than NULL. IE NULL is ALWAYS less.
	// Its the best we can do with two return codes
	// "true" or "false".
	if ((&other==NULL)&&(this==NULL)) return false;
	if ((&other==NULL)&&(this!=NULL)) return false;
	if ((&other!=NULL)&&(this==NULL)) return true;

	// is it the same obj ?
	if (&other==this) return (false);

	// do compare
	if (strncmp(buf,other.buf,length)<0) { return (true); } else { return (false); }
	} /////////////////////////////////////////////////////////////////////////////end operator<

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator<
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator<(const char *other)
{
	// trivial cases
	// the reasoning here is a value that exists 
	// cant be less than NULL. IE NULL is ALWAYS less.
	// Its the best we can do with two return codes
	// "true" or "false".
	if ((other==0)&&(this==NULL)) return false;
	if ((other==0)&&(this!=NULL)) return false;
	if ((other!=0)&&(this==NULL)) return true;

	// do compare
	if (strncmp(buf,other,length)<0) { return (true); } else { return (false); }
	} /////////////////////////////////////////////////////////////////////////////end operator<

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator>
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator>(const CString &other)
{
	// trivial cases
	// the reasoning here is a value that exists 
	// cant be less than NULL. IE NULL is ALWAYS less.
	// Its the best we can do with two return codes
	// "true" or "false".
	if ((&other==NULL)&&(this==NULL)) return false;
	if ((&other==NULL)&&(this!=NULL)) return true;
	if ((&other!=NULL)&&(this==NULL)) return false;

	// is it the same obj ?
	if (&other==this) return (false);

	// do compare
	if (strncmp(buf,other.buf,length)>0) { return (true); } else { return (false); }
	} /////////////////////////////////////////////////////////////////////////////end operator>

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator>
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator>(const char *other)
{
	// trivial cases
	// the reasoning here is a value that exists 
	// cant be less than NULL. IE NULL is ALWAYS less.
	// Its the best we can do with two return codes
	// "true" or "false".
	if ((other==0)&&(this==NULL)) return false;
	if ((other==0)&&(this!=NULL)) return true;
	if ((other!=0)&&(this==NULL)) return false;

	// do compare
	if (strncmp(buf,other,length)>0) { return (true); } else { return (false); }
	} /////////////////////////////////////////////////////////////////////////////end operator>

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator==
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator==(const CString &other)
{

	// trivial cases
	if (&other==NULL)
	{
		if (this==NULL) return (true); 
		else return (false);
		}

	if (&other==this) return (true);
	if (length!=other.length) return (false);

	// do compare
	if (strncmp(buf,other.buf,length)==0) { return (true); } else { return (false); }
	} ////////////////////////////////////////////////////////////////////////////end operator==

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator==
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator==(const char *other)
{

	// trivial case
	if (this==NULL)
	{
		if (other==0) return (true); 
		else return (false);
		}
	if (length!=(int)strlen(other)) return(false);

	// do compare
	if (strncmp(buf,other,length)==0) { return (true); } else { return (false); }
	} ////////////////////////////////////////////////////////////////////////////end operator==

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator!=
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator!=(const CString &other)
{

	// trivial cases
	if (&other==NULL)
	{
		if (this==NULL) return (false); 
		else return (true);
		}
	if (&other!=this) return (true);
	if (length!=other.length) return (true);

	// do compare
	if (strncmp(buf,other.buf,length)!=0) { return (true); } else { return (false); }
	} ////////////////////////////////////////////////////////////////////////////end operator!=

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator!=
// overload
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::operator!=(const char *other)
{

	// trivial case
	if (this==NULL)
	{
		if (other==0) return (false); 
		else return (true);
		}
	if (length!=(int)strlen(other)) return(true);

	// do compare
	if (strncmp(buf,other,length)!=0) { return (true); } else { return (false); }
	} ////////////////////////////////////////////////////////////////////////////end operator!=

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator+
////////////////////////////////////////////////////////////////////////////////////////////////////
CString CString::operator+(const CString &other)
{
CString temps;

	// 
	temps.SetString(buf);
	
	temps.Append(other.buf);
	return CString(temps);
	} /////////////////////////////////////////////////////////////////////////////end operator+

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator+
////////////////////////////////////////////////////////////////////////////////////////////////////
CString CString::operator+(const char *other)
{
CString temps;

	// 
	temps.SetString(buf);
	
	temps.Append(other);
	return CString(temps);
	} /////////////////////////////////////////////////////////////////////////////end operator+

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString operator+
////////////////////////////////////////////////////////////////////////////////////////////////////
CString operator+(const char *first, const CString &second)
{
CString temps;

	// 
	temps.SetString(first);
	
	temps.Append(second.buf);
	return CString(temps);
	} /////////////////////////////////////////////////////////////////////////////end operator+

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString StrNCmp
// Compare first N characters of the cstring with given string
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::StrNCmp(const char *s,int l)
{
	return (strncmp(this->GetStringInt(),s,l));
	} ///////////////////////////////////////////////////////////////////////////////end StrNCmp

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString CompareN
// Compare first N characters of the cstring with given string
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::CompareN(const char *c,int l)
{
int result;

        // trivial case
        if ((this->GetLength())==l)
        {
		result=strncmp(this->GetStringInt(),c,l);
		return(result);
        	}
        else
        {
		result=strncmp(this->GetStringInt(),c,Min(this->GetLength(),l));
                if (result==0)
                {
                        if (this->GetLength()<=l) return(-1);
                        else return (1);
                	}
                else
                {
                        return (strncmp(this->GetStringInt(),c,Min(this->GetLength(),l)));
                	}
        	}
	} //////////////////////////////////////////////////////////////////////////////end CompareN

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetStringPtr
/// We are accessing the internal member on purpose. This is to reduce the time lost in buffer copying.
/// This should be used only as a read only ! Do not write to pointer returned!!!!
////////////////////////////////////////////////////////////////////////////////////////////////////
char *CString::GetStringPtr()
{
	if ((length>0)&&(buf)) return (buf); else return(0);
	} //////////////////////////////////////////////////////////////////////////end GetStringPtr

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetString
// we DID eventually replace this with a create of another buffer
// but problem STILL is if i just want to print it out then i have to create and delete a mem block
// maybe i need to use the stream output methodology
////////////////////////////////////////////////////////////////////////////////////////////////////
char *CString::GetString(char **s)
{

	// create new buf to send out
	*s = new char[length+1];	// remember that length does NOT include \0
	if (*s) strncpy(*s,buf,length+1);
	else *s=0;
	return (*s);

//	if (length>0) return (buf); else return(0);
	} /////////////////////////////////////////////////////////////////////////////end GetString

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetString
////////////////////////////////////////////////////////////////////////////////////////////////////
char *CString::GetStringInt()
{
	if (length>0) return (buf); else return(0);
	} /////////////////////////////////////////////////////////////////////////////end GetString

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Chop
// chop from first occurence of a char to the end
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::Chop(const char *reject)
{
char 	*tmp;
int	n;

	tmp = new char[length+1];
	strncpy(tmp,buf,length+1);
	delete [] buf; 
	n=strcspn(tmp,reject);
	buf=new char[n+1];
	strncpy(buf,tmp,n+1);
	buf[n]='\0';
	delete [] tmp;
	return length=n;
	} //////////////////////////////////////////////////////////////////////////////////end Chop

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Chop
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::Chop()
{
char *temp;

	if (length<=0)
	{
		if (buf) delete [] buf;
		buf=0;
		return(0);
		}
	if (buf==0)
	{
		length=0;
		return(0);
		}

	// chop from existing string
	length -= 1;
	temp=new char[length+1];
	strncpy(temp,buf,length);
	delete [] buf;
	buf=temp;
	buf[length]='\0';
	return (length);
	} //////////////////////////////////////////////////////////////////////////////////end Chop

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString TokenInit
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::TokenInit(const char *c)
{
	// ok, prep for tokenizing from beginning
        nextchar=0;
	strncpy(dstring,c,MAX_DELIM_LEN);
	delim_len=strlen(dstring);
	if (delim_len>MAX_DELIM_LEN) delim_len=MAX_DELIM_LEN;
	tokinitready=true;
	} /////////////////////////////////////////////////////////////////////////////end TokenInit

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString SetDelim
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::SetDelim(const char *c)
{
	if (!tokinitready) return (false);
	strncpy(dstring,c,MAX_DELIM_LEN);
	delim_len=strlen(c);
	if (delim_len>MAX_DELIM_LEN) delim_len=MAX_DELIM_LEN;
	return (true);
	} //////////////////////////////////////////////////////////////////////////////end SetDelim

////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::SelectToken(int *start)
{
int i;

	// check if token delim set
	if (!tokinitready) return (false);

	// handle a special case
	if (length==1)
	{
		// if it is not a delim then just return the single char
		for (i=0;((i<MAX_DELIM_LEN)&&(i<delim_len));i++)
		{
			if (buf[nextchar]==dstring[i]) return false;
			}
		*start=nextchar;
		nextchar++;
		return true;
		}

	// are we done searching for tokens ?
	if (nextchar>=length-1) return (false);

	// if pointing at delim now, point to next char that is not delim
Select1:
	if (nextchar>=length-1) goto Select2;
	for (i=0;((i<MAX_DELIM_LEN)&&(i<delim_len));i++) 
	{
		if (buf[nextchar]==dstring[i]) 
		{
			nextchar++;
			goto Select1;
			}
		}

Select2:
	// record where we start token
	*start=nextchar;
	
	// search for next occurence of delim 
Select3:
	if ((nextchar<length))	
	{
		for (i=0;((i<MAX_DELIM_LEN)&&(i<delim_len));i++)
		{
			if (buf[nextchar]==dstring[i]) goto Select4;
			}
		nextchar++;
		goto Select3;
		}
Select4:
	return (true);

	} ///////////////////////////////////////////////////////////////////////////end SelectToken

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetToken
// Do we want multiple delims to read as a single delim ?
// I think so.
////////////////////////////////////////////////////////////////////////////////////////////////////
CString *CString::GetToken()
{
int	start; 	// where the present token will start
CString	*token;
char	*tbuf;

	// select the token
	if (!SelectToken(&start)) return (NULL);

	// either we found a delim or the end of string was found. in either case return 
	// it as a token.
	tbuf = new char[nextchar-start+1];
	strncpy(tbuf,buf+start,nextchar-start);
	tbuf[nextchar-start]='\0';
	token = new CString;
	token->SetString(tbuf); 
	delete [] tbuf;
	return (token);	
	} //////////////////////////////////////////////////////////////////////////////end GetToken

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetRemainder
////////////////////////////////////////////////////////////////////////////////////////////////////
CString *CString::GetRemainder()
{
int	start; 	// where the present token will start
CString	*remainder;
char	*tbuf;
int	i;

	// check if token delim set
	if (!tokinitready) return (NULL);

	// are we done searching for tokens ?
	if (nextchar>=length-1) return (NULL);

	// if pointing at delim now, point to next
//	if (buf[nextchar]==delim) nextchar++;
Remainder1:
	if (nextchar>=length-1) goto Remainder2;
	for (i=0;((i<MAX_DELIM_LEN)&&(i<delim_len));i++) 
	{
		if (buf[nextchar]==dstring[i]) 
		{
			nextchar++;
			goto Remainder1;
			}
		}
Remainder2:


	// record where we start token
	start=nextchar;
	
	// either we found a delim or the end of string was found. in either case return 
	// it as a token.
	tbuf = new char[length-start+1];
	strncpy(tbuf,buf+start,length-start);
	tbuf[length-start]='\0';
	remainder = new CString;
	remainder->SetString(tbuf); 
	delete [] tbuf;
	return (remainder);	
	
	} //////////////////////////////////////////////////////////////////////////end GetRemainder

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString FGetS
// this will read in chunks of CHUNKLENGTH bytes until a newline is read
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::FGetS(FILE *f)
{
char	*tbuf,*res;
int	tl;

	// if there is a buffer delete it and reload
	if (buf)
	{
		// delete old buffer
		delete [] buf;
		length=0;
		buf=0;
		}

	// make a work buf
	tbuf = new char[CHUNKLENGTH];

	// get the data
	do
	{
		// get next chunk
		res=fgets(tbuf,CHUNKLENGTH,f);
		if (res) tl=strlen(tbuf);
		else tl=0;

		if (res)
		{
			// is there a buf yet ?
			if(!buf)
			{
				// create buf
				buf = new char[tl+1];	// we don't count \0 as strlen
				strncpy(buf,tbuf,tl+1);	// copy upto and including any \0
				length=strlen(buf);
				}
			else
			{
			char *oldbuf;
	
				oldbuf=buf;
				
				// get new bigger buf
				buf = new char [length+tl+1];
				strncpy(buf,oldbuf,length);
				strncpy(buf+length,tbuf,tl+1);
				length=length+tl;
				delete [] oldbuf;
				}
			}
		} while (tl==CHUNKLENGTH-1);

	delete [] tbuf;
	return (true);
	} /////////////////////////////////////////////////////////////////////////////////end FGetS

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetLine
// this will read in chunks of CHUNKLENGTH bytes until a newline is read
// GETLINE USES MALLOC AND FREE INTERNALLY !!!
// But we pass back a new'd buffer, not Malloc'd
// Returns false on error or EOF
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::GetLine(FILE *f)
{
ssize_t	res;
size_t	l;
char	*tbuf;

	// if there is a buffer delete it and reload
	if (buf)
	{
		// delete old buffer
		delete [] buf;
		length=0;
		buf=0;
		}

	// Get the line upto and including \n
	tbuf=0;
	l=0;

#ifdef LINUX
	res=getline(&tbuf,&l,f);
#endif
#ifdef SOLARIS
	res=mygetline(&tbuf,&l,f);
#endif

	if (res==-1) 
	{
		buf=0;
		length=0;
		return false;
		}
	else 
	{
		length=(int)res;
		assert(length>0);
		buf = new char[length+1];
		strncpy(buf,tbuf,length);
		if (tbuf) free(tbuf);
		buf[length]='\0';
		return true;
		}
	} ///////////////////////////////////////////////////////////////////////////////////GetLine

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Chomp
// Get Rid of non printable characters
////////////////////////////////////////////////////////////////////////////////////////////////////
void CString::Chomp()
{
int	i;
bool	done;

	done=false;
	i=length-1;

	// start at end and work back
	while ((i>0)&&(!done))
	{
		// look for non print chars
		if (buf[i]<' ')
		{
			buf[i]='\0';
			i--;
			}	
		else done=true;
		}
	length=strlen(buf);
	} /////////////////////////////////////////////////////////////////////////////////end Chomp

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetFloat
// Returns true if there was one conversion
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::GetFloat(float *fl)
{
int	start; 	// where the present token will start
float	f;
int 	result;

	*fl=0.0;
	if (!SelectToken(&start)) { return (false); }

	// scan token
	result=sscanf(buf+start,"%f",&f);
	*fl=f;
	if (result==1) return (true); else return false;
	} //////////////////////////////////////////////////////////////////////////////end GetFloat

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetInt
// Returns true if there was one conversion
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::GetInt(int *il)
{
int	start; 	// where the present token will start
int	i;
int 	result;

	*il=0;
	if (!SelectToken(&start)) { return (false); }

	// scan token
	result=sscanf(buf+start,"%d",&i);
	*il=i;
	if (result==1) return (true); else return false;
	} ////////////////////////////////////////////////////////////////////////////////end GetInt

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetLongInt
// Returns true if there was one conversion
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::GetLongInt(long int *il)
{
int	start; 	// where the present token will start
long int	i;
int 	result;

	*il=0;
	if (!SelectToken(&start)) { return (false); }

	// scan token
	result=sscanf(buf+start,"%ld",&i);
	*il=i;
	if (result==1) return (true); else return false;
	} ////////////////////////////////////////////////////////////////////////////end GetLongInt

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString GetULongInt
// Returns true if there was one conversion
////////////////////////////////////////////////////////////////////////////////////////////////////
bool CString::GetULongInt(unsigned long int *il)
{
int			start; 	// where the present token will start
unsigned long int	i;
int 	result;

	*il=0;
	if (!SelectToken(&start)) { return (false); }

	// scan token
//	sscanf(buf+start,"%lu",&i);
	result=sscanf(buf+start,"%lu",&i);
	*il=(unsigned long)i;
	if (result==1) return (true); else return false;
	} ///////////////////////////////////////////////////////////////////////////end GetULongInt

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString ConvertBinary
// Convert all instances of '\','n' to a new line char or '\','t' to a tab
// Add others as we find them
// chars converted so far
// \, nt0
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::ConvertBinary()
{
int	i;
int	special;
int	p;
int	count;
char	*newbuf;
	
	if (buf==0) return(0);
	if (length==0) return(0);

	// count specials
	special=0;
	for (i=0; i<length; i++)
	{
		if ((buf[i]<' ') || (buf[i]>'~')) special++;
		}

	// copy and adjust
	newbuf=new char[length+special+1];			// term null not included in length
	p=0;
	count=0;
	for (i=0; i<length; i++)	// i points into old buffer
	{
		if ((buf[i]>=' ') && (buf[i]<='~')) 
		{
			newbuf[p]=buf[i];
			p++;
			}
		else
		{
			newbuf[p]='\\';
			p++;
			if (buf[i]==10) newbuf[p]='n';
			if (buf[i]==9) newbuf[p]='t';
			p++;
			count++;
			}
		}

	// done adjusting now fix up bufs
	newbuf[p]='\0';
	delete [] buf;
	buf=newbuf;
	length=length+special;
	
	return count;
	
	} /////////////////////////////////////////////////////////////////////////end ConvertBinary

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString ConvertBackSlash
// Convert all instances of '\','n' to a new line char or '\','t' to a tab
// Add others as we find them
// chars converted so far
// \, nt0
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::ConvertBackSlash()
{
char	*newbuf;
int	i,p;
int	count;

	// read through string and convert all coded chars to actual codes
	// '/','n'   become the newline char, etc

	if (buf==0) return(0);
	if (length==0) return(0);

	newbuf=new char[length+1];			// term null not included in length

	p=0;		// points into NEW buffer
	count=0;
	for (i=0; i<length; i++)	// i points into old buffer
	{
		if (buf[i]!='\\') // BECAREFUL THIS IS A SINGLE backslash CHARACTER COMPARISON
		{
			newbuf[p++]=buf[i];
			}
		else
		{
			if (buf[i+1]=='n') 
			{
				newbuf[p++]='\n';
				i++;
				i++;
				count++;
				}
			else if (buf[i+1]=='t')
			{
				newbuf[p++]='\t';
				i++;
				i++;
				count++;
				}
			else if (buf[i+1]=='0')
			{
				newbuf[p++]='\0';
				i++;
				i++;
				count++;
				}
			}
		}

	// done converting, now copy to buff
	newbuf[p]='\0';
	delete [] buf;
	buf = new char[p+1];	// the way this works out it should have the extra byte for the \0

	strncpy(buf,newbuf,p+1);
	length=p;
	delete [] newbuf;
	return (count);

	} //////////////////////////////////////////////////////////////////////end ConvertBackSlash

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Append (Overloaded)
// Returns true if there was one conversion
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::Append(int addition)
{
char	tempbuf[INT_LEN]; 
int	r;

	// do the conversion
	r=snprintf(tempbuf,INT_LEN,"%d",addition);

	// use existing append to append
	IntAppend(tempbuf);
	return r;

	} ////////////////////////////////////////////////////////////////////////////////end GetInt

////////////////////////////////////////////////////////////////////////////////////////////////////
// CString Append (Overloaded)
// Returns true if there was one conversion
////////////////////////////////////////////////////////////////////////////////////////////////////
int CString::Append(unsigned long int addition)
{
char	tempbuf[ULINT_LEN]; 
int	r;

	// do the conversion
	r=snprintf(tempbuf,ULINT_LEN,"%lu",addition);

	// use existing append to append
	IntAppend(tempbuf);
	return r;

	} ////////////////////////////////////////////////////////////////////////////////end GetInt




