/////////////////////////////////////////////////////////////////////////////////////
// cthread.cpp
// This class will implement a thread managment scheme 
// 
// by Eric J Krejci
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jan 2006
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation version 2.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact:
//              email           worldii@viagloria.com
//              web             www.viagloria.com
/////////////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <curses.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "cthread.hpp"	   
#include "wiii_util.h"	   

/////////////////////////////////////////////////////////////////////////////////////
// Externals
/////////////////////////////////////////////////////////////////////////////////////
//extern pthread_attr_t  attr;

/////////////////////////////////////////////////////////////////////////////////////
// Local Globals
/////////////////////////////////////////////////////////////////////////////////////
static int 	tcount;

/////////////////////////////////////////////////////////////////////////////////////
// Init
// Initialize the instance
/////////////////////////////////////////////////////////////////////////////////////
bool CThreadList::Init()
{
     // Initialize the instance
     return (true);

     } //////////////////////////////////////////////////////////////////////end Init

/////////////////////////////////////////////////////////////////////////////////////
// CThread Constructor
/////////////////////////////////////////////////////////////////////////////////////
CThreadList::CThreadList()
{
int i;

     // Initialize the instance
     for (i=0;i<MAXTHREADS;i++)
     {
          // zero out the array
          threadlist[i]=0;
          }
     ::tcount=0;
     }////////////////////////////////////////////////////////////////end Constructor

/////////////////////////////////////////////////////////////////////////////////////
// CThread Destructor
/////////////////////////////////////////////////////////////////////////////////////
CThreadList::~CThreadList()
{
     // free the memory pointed to by buf
     }/////////////////////////////////////////////////////////////////end Destructor

/////////////////////////////////////////////////////////////////////////////////////
// StartThread
/////////////////////////////////////////////////////////////////////////////////////
int CThreadList::StartThread(void *func(void *),void *parm)
{
//int 		retval;
pthread_t 	ttemp;
//static int 	tcount;

	// start thread & record stats 
	if ( ::tcount < MAXTHREADS )
	{
//		pthread_create( &ttemp, &attr, func, parm);
		CreateThread( &ttemp, func, parm);
		threadlist[ ::tcount ]=ttemp;
		return(0);
		}
	else
	{
		return(ERR_TOOMANYTHREADS);
		}
	}////////////////////////////////////////////////////////////////end StartThread

/////////////////////////////////////////////////////////////////////////////////////
// PauseThread
/////////////////////////////////////////////////////////////////////////////////////
int CThreadList::PauseThread()
{
int  sentsize;

     return(sentsize);
     }////////////////////////////////////////////////////////////////end PauseThread

/////////////////////////////////////////////////////////////////////////////////////
// TermThread
/////////////////////////////////////////////////////////////////////////////////////
int CThreadList::TermThread()
{
int  sentsize;

     return(sentsize);
     }/////////////////////////////////////////////////////////////////end TermThread

/////////////////////////////////////////////////////////////////////////////////////
// KillThread
/////////////////////////////////////////////////////////////////////////////////////
int CThreadList::KillThread()
{
int  sentsize;

     return(sentsize);
     }/////////////////////////////////////////////////////////////////end KillThread


