////////////////////////////////////////////////////////////////////////////////////////////////////
// cwutil.cpp   
// This is just some cworld utilities  
// 
// by Eric J Krejci 
// Copyright (C) 1999 Eric J Krejci 
// Revised : 26 Jan 2006
//   
////////////////////////////////////////////////////////////////////////////////////////////////////
#include <pthread.h>
#include <math.h>

#include "cworld.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Defines
////////////////////////////////////////////////////////////////////////////////////////////////////
// constant used for converting to radians 
const float pideg = 0.0174532925f;

////////////////////////////////////////////////////////////////////////////////////////////////////
// Externals
////////////////////////////////////////////////////////////////////////////////////////////////////
extern bool	debug;

////////////////////////////////////////////////////////////////////////////////////////////////////
// CheckForGLErrors 
////////////////////////////////////////////////////////////////////////////////////////////////////
void CheckForGLErrors(void (*logfunc)(char*))
{
GLenum	e;
char	buf[BUFFSIZE];

//	if (logfunc) (*logfunc)(s);
	e=0;
	e=glGetError();
	while (e!=0)
	{
		snprintf(buf,BUFFSIZE,"CheckForGLErrors: e=%d",e);
		if (logfunc) (*logfunc)(buf);
		e=glGetError();
		}
	} ////////////////////////////////////////////////////////////////////////////end Destructor

////////////////////////////////////////////////////////////////////////////////////////////////////
// PrintCWorldError 
////////////////////////////////////////////////////////////////////////////////////////////////////
void PrintCWorldError(int e)
{
	switch (e)
	{
	case CW_OK:
		printf("No Error.\n");
		break;

	case CW_ERR_FILE_OPEN:
		printf("Error: File open.\n");
		break;

	case CW_ERR_CONVERSION:
		printf("Error: Conversion.\n");
		break;

	case CW_ERR_TEXLOAD:
		printf("Error: Texture loading error.\n");
		break;

	case CW_ERR_RENDER:
		printf("Error: Render error.\n");
		break;

	case CW_ERR_SUBMODLOAD:
		printf("Error: Sub model load error.\n");
		break;

	case CW_ERR_SUBPARTLOAD:
		printf("Error: Sub part load error.\n");
		break;

	case CW_ERR_MEMALLOCATE:
		printf("Error: Memory allocation error.\n");
		break;

	case CW_ERR_UKNOWNLIST:
		printf("Error: Unknown list type error.\n");
		break;

	default:
		printf("Error: Unhandled Error.\n");
		}

	} //////////////////////////////////////////////////////////////////////end PrintCWorldError
