\! echo '/////////////////////////////////////////////////////////////'
\! echo '// GraphicsBuild.sql'
\! echo '// This builds the worldii data base graphical test data'
\! echo '// '
\! echo '// by Eric J Krejci'
\! echo '// Copyright Eric J Krejci December 1999'
\! echo '// Revised : 12 Oct 2000'
\! echo '/////////////////////////////////////////////////////////////'

\! echo Vertex
CREATE TABLE Vertex 
(
     Said 		int8		NOT NULL UNIQUE ,
     X			int8		NOT NULL        ,
     Y			int8	        NOT NULL        ,
     Z			int8	        NOT NULL        ,
     DX			float		NOT NULL        ,
     DY			float	        NOT NULL        ,
     DZ			float	        NOT NULL        ,
     TU			float	        NOT NULL        ,
     TV			float	        NOT NULL        ,

     PRIMARY KEY   
     (
          Said
          )
     )
;

\! echo Strips
CREATE TABLE Strips 
(
     Said 		int8		NOT NULL UNIQUE ,
     Count              int		NOT NULL        ,

     PRIMARY KEY   
     (
          Said
          )
     )
;

\! echo StripIndecies
CREATE TABLE StripIndecies
(
     StripsSaidFkey       int8            NOT NULL        ,
     VertexSaidFkey       int8            NOT NULL        ,
     VertOrder		  int		  NOT NULL        ,

     CONSTRAINT SItoV FOREIGN KEY
     (
          VertexSaidFkey
          )
     REFERENCES Vertex
     (
          Said
          ),

     CONSTRAINT VTEtoE FOREIGN KEY
     (
          StripsSaidFkey
          )
     REFERENCES Strips
     (
          Said
          )

     )
;

\! echo Representation
CREATE TABLE Representation
(
     Said               int8            NOT NULL UNIQUE ,
     Name               char(20)        NOT NULL        ,

     PRIMARY KEY
     (
          Said
          )


     )
;

\! echo StripsInReps
CREATE TABLE StripsInReps
(
     StripsSaidFkey       int8            NOT NULL        ,
     RepSaidFkey        int8            NOT NULL         ,

     CONSTRAINT SIRtoS FOREIGN KEY
     (
          StripsSaidFkey
          )
     REFERENCES Vertex
     (
          Said
          ),

     CONSTRAINT SIRtoR FOREIGN KEY
     (
          RepSaidFkey
          )
     REFERENCES Representation
     (
          Said
          )

     )
;


\! echo RepToObj
CREATE TABLE RepToObj
(
     ObjSaidFkey        int8            NOT NULL        ,
     RepSaidFkey        int8            NOT NULL

     )
;


